﻿//clase GestorAutomata
//Autor: Javier Cuesta González de la Aleja
//esta clase será la utilizada en todas aquellas actividades donde
//pasemos de una escena a otra (ya sea de forma secuencial o no)
//donde el funcionamiento sea parecido al de un automata de estados

class GestorAutomata implements gEvaluacionCondicion {
	//en el array de saltos tendremos el estado siguiente (escena) y si no es secuencial tendremos la condicion y el estado 
	private var _estados: Array;  
	private var _secuencial: Boolean;
	private var _estadoActual: String;
	
	public function GestorAutomata (estados: Array, secuencial:Boolean, estadoActual:String){
		this._estados = estados;
		this._secuencial = secuencial;
		this._estadoActual = estadoActual;
		}
	
	//devuelve el estado actual de nuestro automata
	public function darEstadoActual ():String{
		return this._estadoActual;
		}
	
	//public function seCumpleCondicion(salto: saltoYpregunta){
	//en esta funcion pondríamos a true el valor de la condicion del salto si se cumple una determinado condicion
	//tendremos que ver cuales son las posibles condiciones que se puedan dar.
		//}
	//avanza al estado siguiente si es un automata secuencial, si no lo es vemos si se cumple la condición para saltar
	public function transito (){
		var encontrado:Boolean = false;
		var encontrado2:Boolean = false;
		var i:Number = 0;
		var j:Number = 0;
		var miestado : estado;
		var misaristas: Array;
		var miarista: arista;
		while (encontrado == false && i < this._estados.length){
			miestado = this._estados[i];
			if (miestado.GetNombre() == this._estadoActual){
				misaristas = miestado.GetListaAristas();
				encontrado = false;
				while (encontrado2 == false && j<misaristas.length) {
					miarista = misaristas[j];
					if (miarista.GetCondicion()){
						this._estadoActual = miarista.GetEstadoDestino();
						encontrado2 = true;
						}
						j++;
					}
				}
				i++;
			}
		}
	
	//marca como visitado el estado en el que nos encontremos, esta funcion habria que hacerla antes del transito
	public function marcadoVisitado(){
		var encontrado:Boolean = false;
		var i:Number = 0;
		var miestado : estado;
		while (encontrado == false && i < this._estados.length){
			miestado = this._estados[i];
			if (miestado.GetNombre() == this._estadoActual){
				miestado.PutVisitado();
				encontrado = true;
				}
			i++;
			}
		}

	//nos devuelve el identificador del texto/audio que se preguntará en ese estado
	public function generarPregunta():String{
		var encontrado:Boolean = false;
		var i:Number = 0;
		var miestado : estado;
		var res: String;
		while (encontrado == false && i < this._estados.length){
			miestado = this._estados[i];
			if (miestado.GetNombre() == this._estadoActual) {
				res = miestado.GetPregunta();
				encontrado = true;
				}
			i++;
			}
		return res;
		}
		
	//comienzo de la implementacion de la interfaz gEvaluacionCondicion
	
	public function evaluarCondicion(miarista: arista):Boolean{
		return miarista.GetCondicion();
		}
	
	public function comprobarIgualdad (elemento: elementoActividad, significado: String): Boolean{
		var res: Boolean = false;
		if (elemento.GetSignificado() == significado){
			res = true;
			}
		return res;
		}
	//fin implementacion de la interfaz
}