﻿//clase GestorEmparejamientos
//Autor: Javier Cuesta González de la Aleja
// esta clase será utilizada en todas las actividades donde tengamos en alguna escena
//varios elementos y tengamos que comparar su significado, normalmente será en actividades
//donde exista la posibilidad de ver la evaluacion del alumno, contando los aciertos y fallos.
//Esta clase implementa los métodos de la clase interfaz gSignificado

import elementoActividad;

//El array de elementos debe tener al menos id y significado
 class GestorEmparejamientos implements gSignificado {
	//array de elementos que me pasan como parámetro
	private var _myArrayObjetos: Array;
	private var _mcActual: MovieClip;
	private var _mcAnterior: MovieClip;
	private var _idActual: String;
	private var _idAnterior: String;
	
	
	//inicializo el gestor de emparejamientos asignando a myArray la lista d eobjetos que se pasa por parametro
	//y los movieclips para los que comprobaremos su significado
	public function GestorEmparejamientos (arrayObjetos:Array, mcActual:MovieClip, mcAnterior:MovieClip ){
		this._myArrayObjetos = arrayObjetos;
		this._mcActual = mcActual;
		this._mcAnterior = mcAnterior;
	}
	
	public function introActual (mcActual:MovieClip){
		this._mcActual = mcActual;
	}
	
	public function GetActual ():MovieClip{
		return this._mcActual;
	}
	
	public function introAnterior (mcAnterior:MovieClip){
		this._mcAnterior = mcAnterior;
	}
	
	public function GetAnterior ():MovieClip{
		return this._mcAnterior;
	}
	
	public function introIdActual (idActual:String){
		this._idActual = idActual;
	}
	
	public function GetIdActual ():String{
		return this._idActual;
	}
	
	public function introIdAnterior (idAnterior:String){
		this._idAnterior = idAnterior;
	}
	
	public function GetIdAnterior ():String{
		return this._idAnterior;
	}
	
	public function inicializarSeleccionados(){
		this._mcActual = null;
		this._mcAnterior = null;
	}
			
	public function inicializarActual(){
		this._mcActual = null;
	}
	public function inicializarIdActual(){
		this._idActual = "";
	}
	//comprobamos si es correcto el emparejamiento
	// para comprobarPareja, cogeré los objetos seleccionados y buscaré su significado.
	//antes de llamar ha este servivio se tendrá que comprobar si anteriormente ha habido otra
	//seleccion, es decir, mcAnterior /= null.
	//Por otra parte en el lugar donde se llame a este metodo, tendremos que bloquear y desbloquear los objetos
	//dependiendo de la comprobacion
	public function comprobarParejaXids():Boolean{
		var significado1:String; //significado Objeto1
		var significado2:String; //significado Objeto2
		var iguales: Boolean = false;
		//utilizo la función de la interfaz gSignificado para que me de el significado de los objetos que deseo comparar
		significado1 = darSignificado (_myArrayObjetos, _idAnterior);
		significado2 = darSignificado (_myArrayObjetos, _idActual);
		//miro si coinciden los objetos
		if (significado1 == significado2){
			iguales = true;
		}
		return iguales;
	}//comprobarPareja
	
	public function comprobarPareja():Boolean{
		var significado1:String; //significado Objeto1
		var significado2:String; //significado Objeto2
		var iguales: Boolean = false;
		var id_objeto1: String;
		var id_objeto2: String;
		//busco el objeto1
		id_objeto1 = buscarObjeto(_myArrayObjetos, _mcAnterior);
		//busco el objeto2
		id_objeto2 = buscarObjeto(_myArrayObjetos, _mcActual);
		//utilizo la función de la interfaz gSignificado para que me de el significado de los objetos que deseo comparar
		significado1 = darSignificado (_myArrayObjetos, id_objeto1);
		significado2 = darSignificado (_myArrayObjetos, id_objeto2);
		//miro si coinciden los objetos
		if (significado1 == significado2){
			iguales = true;
		}
		return iguales;
	}//comprobarPareja
	//teniendo una lista de objetos y dado uno de los objetos 
	public function buscarObjeto(lista:Array, seleccionado:MovieClip):String{
		var i:Number = 0;
		var id_objeto: String;
		var objeto: elementoActividad;
		var encontrado:Boolean = false;
		while(encontrado == false && i < lista.length){
			objeto = lista[i];
			if(objeto.GetMovieClip() == seleccionado){
				encontrado = true;
				id_objeto = lista[i].GetId();
				}
				i++;
			}
			return id_objeto;
	}//fin buscarObjeto
	
	//teniendo una lista de objetos y dado uno de los objetos 
	public function darObjeto(lista:Array, seleccionado:MovieClip):elementoActividad{
		var i:Number = 0;
		var objeto: elementoActividad;
		var objeto2: elementoActividad;
		var encontrado:Boolean = false;
		while(encontrado == false && i < lista.length){
			objeto = lista[i];
			if(objeto.GetMovieClip() == seleccionado){
				encontrado = true;
				objeto2 = lista[i];
				}
				i++;
			}
			return objeto2;
	}//fin buscarObjeto
	
	
	public function introSignificado (objeto: elementoActividad, nuevo_significado: String){
		objeto.PutSignificado(nuevo_significado);
	}
	//introduce en la lista de elementos el significado de uno de los elementos
	public function introSignificadoLista (lista: Array, nuevo_significado: String, id: String){
		var i: Number = 0;
		var idObjeto: String;
		var encontrado: Boolean = false;
		while (encontrado == false && i<lista.length){
			idObjeto = lista[i].GetId ();
			if (idObjeto == id){
				introSignificado(lista[i], nuevo_significado);
				encontrado = true;
			}
			i++;
		}
	}
	//dada una lista de objetos y un id, devuelve el significado del objeto cuyo identoficador es id
	public function darSignificado (lista: Array, id: String): String{
		var i: Number = 0;
		var res: String;
		var idObjeto:String;
		var objeto: elementoActividad;
		var encontrado:Boolean = false;
		while ((encontrado == false) && (i<lista.length)){
			idObjeto = lista[i].GetId();
			if (idObjeto == id){
				res = lista[i].GetSignificado();
				encontrado = true;
			}
			i++;
		}
		return res;
	}
	//devuelve una lista con los identificadores de todos los elementos del array que tengan el mismo significado 
	public function significadosIguales (lista: Array, significado: String): Array{
		var i: Number = 0;
		var j: Number = 0;
		var res: Array = new Array (lista.length);
		var sigObjeto: String;
		while (i < lista.length){
			sigObjeto = lista[i].GetSignificado();
			if (sigObjeto == significado){
				res[j] = lista[i].GetId();
				j++;
			}
			i++
		}
		return res;
	}
	//fin implementacion de la clase interfaz

}
