﻿class GestorEvaluacion {
	
	private var _evaluaciones: Array;
	private var _ultimo:Number;
	private var MAX_NIVELES:Number = 3;

	public function GestorEvaluacion () {
		//Inicializo las evaluaciones que habrá
		_evaluaciones = new Array();
		for (var i=0;i<MAX_NIVELES;i++){
			var evaluacion = new Object();
			evaluacion.intentos = 0;
			evaluacion.aciertos = 0;
			_evaluaciones.push(evaluacion);
		}
		_ultimo = 0;
	}
	
	public function evaluarNivel(nivel:Number) {
		if ((nivel < 1 ) or (nivel > MAX_NIVELES)){
			trace ("Error: Nivel fuera del rango permitido");
		}
		else{
			_evaluaciones[nivel-1].aciertos = 0;
			_evaluaciones[nivel-1].intentos = 0;
			//Establezco el nivel como último evaluado.
			_ultimo = nivel;
		}
	}
	
	public function establecerEstadisticas(nivel:Number, aciertos:Number, intentos:Number){
		if ((nivel < 1 ) or (nivel > MAX_NIVELES)){
			trace ("Error: Nivel fuera del rango permitido");
			return;
		}
		if (aciertos > intentos) {
			trace("Error: Los aciertos (" + aciertos + ") no deben ser mayores que los intentos (" + intentos + ")");
			return;
		}
		if (aciertos != undefined)
			_evaluaciones[nivel-1].aciertos = aciertos;
		if (intentos != undefined)
			_evaluaciones[nivel-1].intentos = intentos;
		//Establezco el nivel como último evaluado.
		_ultimo = nivel;
	}
	
	public function sumarAcierto(nivel:Number) {
		if (nivel == undefined)
			nivel = _ultimo;
		if (_evaluaciones[nivel-1] != undefined) {
			_evaluaciones[nivel-1].aciertos++;
			_evaluaciones[nivel-1].intentos++;
		}
		else
			trace("Error: Evaluación " + nivel + " no encontrada.");
	}
	
	public function sumarIntento(nivel:Number) {
		if (nivel == undefined)
			nivel = _ultimo;
		if (_evaluaciones[nivel-1] != undefined) {
			_evaluaciones[nivel-1].intentos++;
		}
		else
			trace("Error: Evaluación " + nivel + " no encontrada.");
	}
	
	public function obtenerAciertos(nivel:Number):Number {
		if (nivel == undefined)
			nivel = _ultimo;
		return (_evaluaciones[nivel-1].aciertos);
	}
	
	public function obtenerFallos(nivel:Number):Number {
		if (nivel == undefined)
			nivel = _ultimo;
		return (_evaluaciones[nivel-1].intentos - _evaluaciones[nivel-1].aciertos);
	}

	public function obtenerIntentos(nivel:Number):Number {
		if (nivel == undefined)
			nivel = _ultimo;
		return (_evaluaciones[nivel-1].intentos);
	}

	public function obtenerProporcion(nivel:Number):Number {
		if (nivel == undefined)
			nivel = _ultimo;
			
		if (_evaluaciones[nivel-1].intentos == 0)
			return 0;
			
		return (_evaluaciones[nivel-1].aciertos/_evaluaciones[nivel-1].intentos);
	}
	
	public function obtenerPorcentaje(nivel:Number):Number {
		if (nivel == undefined)
			nivel = _ultimo;
			
		if (_evaluaciones[nivel-1].intentos == 0)
			return 0;
	
		return (_evaluaciones[nivel-1].aciertos/_evaluaciones[nivel-1].intentos)*100;
	}
	
	public function obtenerUltimoEvaluado() {
		return _ultimo;
	}
	
	public function trazarEvaluacion(nivel: Number){
		if (nivel == undefined)
			nivel = _ultimo;
		trace("Evaluación: " + nivel + newline +
			  "  Aciertos: " + obtenerAciertos(nivel) + newline +
			  "  Intentos: " + obtenerIntentos(nivel) + newline +
			  "Porcentaje: " + obtenerPorcentaje(nivel) + "%");
	}
	
	public function imprimirEvaluacion(origen){
		var imprimirDoc:PrintJob = new PrintJob(); //Creo el objeto PrintJob, que es la mínima expresión que han incorporado los de tontomedia para imprimir
		if (imprimirDoc.start()) { //arranco el objeto PrintJob
			trace("ORIENTACIÓN: " + imprimirDoc.orientation);
			if (imprimirDoc.orientation == "portrait") {
				origen._xscale = 71;
				origen._yscale = 71;
			}
			else{
				origen._xscale = 92;
				origen._yscale = 92;
			}
			if (imprimirDoc.addPage (eval(origen))){ //le meto la página y si no da error
				imprimirDoc.send(); //se envía a la impresora
			}
		}
		origen._xscale = 100;
		origen._yscale = 100;
		delete imprimirDoc; //elimino el objeto que ya no me hace falta
	}
}