﻿//clase GestorEvaluacionActividad
//Autor: Javier Cuesta González de la Aleja

class GestorEvaluacionActividad {
	private var _aciertos: Number;
	private var _fallos:Number;
	private var _intentos:Number;
	private var _nelementos:Number; 

	//HMC: Se añaden argumentos para la permitir la deserialización de las instancias
	public function GestorEvaluacionActividad ( nelementos:Number, intentos:Number, aciertos:Number, fallos:Number ) {
		//Inicializo las evaluaciones que habrá
		this._aciertos = aciertos || 0;
		this._fallos = fallos || 0;
		this._intentos = intentos || 0;
		this._nelementos = nelementos || 0;
	}

	public function introNelementos (n:Number){
		this._nelementos = n;
	}

	public function obtenerNelementos():Number {
		return this._nelementos;
	}

	
	public function sumarAcierto() {
		this._aciertos++;
		this._intentos++;
		trace ("aciertos: "+ this._aciertos);
		trace ("intentos: "+ this._intentos);
	}
	
	public function sumarFallo() {
		this._fallos++;
		this._intentos++;
		trace ("fallos: "+ this._fallos);
		trace ("intentos: "+ this._intentos);
	}
	
	public function todoCorrecto(): Boolean {
		return (this._intentos == this._nelementos);
	}
	
	public function finEvaluacion(): Boolean {
		return (this._aciertos == this._nelementos);
	}
	
	public function obtenerAciertos():Number {
		return this._aciertos;
	}
	
	public function obtenerFallos():Number {
		return this._fallos;
	}

	public function obtenerIntentos():Number {
		return this._intentos;
	}

	public function obtenerProporcion():Number {
		return (this._aciertos/this._intentos);
	}
	
	public function obtenerPorcentaje():Number {
		return (this._aciertos/this._intentos)*100;
	}
	
	public function trazarEvaluacion(){
		trace("  Aciertos: " + obtenerAciertos() + newline +
			  "  Fallos: " + obtenerFallos() + newline +
			  "  Intentos: " + obtenerIntentos() + newline +
			  "Porcentaje: " + obtenerPorcentaje() + "%");
	}
	
	public function imprimirEvaluacion(origen){
		var imprimirDoc:PrintJob = new PrintJob(); //Creo el objeto PrintJob, que es la mínima expresión que han incorporado los de tontomedia para imprimir
		if (imprimirDoc.start()) { //arranco el objeto PrintJob
			trace("ORIENTACIÓN: " + imprimirDoc.orientation);
			if (imprimirDoc.orientation == "portrait") {
				origen._xscale = 71;
				origen._yscale = 71;
			}
			else{
				origen._xscale = 92;
				origen._yscale = 92;
			}
			if (imprimirDoc.addPage (eval(origen))){ //le meto la página y si no da error
				imprimirDoc.send(); //se envía a la impresora
			}
		}
		origen._xscale = 100;
		origen._yscale = 100;
		delete imprimirDoc; //elimino el objeto que ya no me hace falta
	}
}