import ParserEvaluacion;
import GestorEvaluacionActividad;

class GestorEvaluacionGlobal
{
	private static var _estructuraSD:Object = 
	{
		_04: [ 
					  { actividades: 5, items: 3 },
					  { actividades: 6, items: 4 },
					  { actividades: 5, items: 3 },
					  { actividades: 5, items: 4 },
					  { actividades: 5, items: 4 }
			    ],
		_05: [ 
					  { actividades: 9, items: 6 },
					  { actividades: 5, items: 6 },
					  { actividades: 7, items: 6 },
					  { actividades: 7, items: 6 },
					  { actividades: 5, items: 6 }
			    ],
		_06: [ 
					  { actividades: 5, items: 4 },
					  { actividades: 9, items: 4 },
					  { actividades: 9, items: 4 },
					  { actividades: 9, items: 1 },
					  { actividades: 9, items: 1 }
			    ]
	};
	
	private var _secuencia:String;
	

  public function GestorEvaluacionGlobal ( secuencia:String )
  {
  	_secuencia = "_" + secuencia;	
  }

  public function getEvaluacionSD() : Array
  {
  	return _level0.evaluaciones;
  }

  private function setEvaluacionSD( e:Array )
  {
  	_level0.evaluaciones = e;
  }

  public function getOAsEjecutadas() : Number
  {
  	return _level0.oas_ejecutadas;
  }

  private function setOAsEjecutadas( n:Number )
  {
  	_level0.oas_ejecutadas = n;
  }
	

  public function getEvaluacionOA( oa:Number ) : Array
  {
    var e:Array = getEvaluacionSD();
    var res:Array = e[ oa - 1 ];
    
  	return res;
  }

  public function getEvaluacionActividad( oa:Number, actividad:Number ) : GestorEvaluacionActividad
  {
    var e:Array = getEvaluacionOA( oa );
    var res:GestorEvaluacionActividad = e[ actividad - 1 ];
    
  	return res;
  }

  public function setEvaluacionActividad( oa:Number, actividad:Number, gea:GestorEvaluacionActividad )
  {
    var e:Array = getEvaluacionOA( oa );
    e[ actividad - 1 ] = gea;
    
    revisaEstadoOA( oa );
  }
  
  public function existeEvaluacion(): Boolean
  {
  	var res:Array = getEvaluacionSD();
  	return ( res != undefined );
  }
  
  public function inicializa(): Boolean
  {
  	var res:Array = undefined;
  	
  	var modelo:Array = _estructuraSD[ _secuencia ];
  	if ( modelo )
  	{
  		var n:Number = modelo.length;
  		res = new Array( n );
  		for ( var i:Number = 0; i < n; i++ )
  		{
  			var o:Object = modelo[ i ];
  			
  			var nActividades:Number = o.actividades;
  			var nItems:Number = o.items;
  			
				var arrayEvalTareas:Array = new Array(nActividades);
				
				arrayEvalTareas.completo = false;
				arrayEvalTareas.iniciado = false;
				
				for ( var j:Number = 0; j < nActividades; j++ )
				{
					var evalTarea = new GestorEvaluacionActividad();
								
					evalTarea.introNelementos( nItems );
					evalTarea.completo = false;
					arrayEvalTareas[j] = evalTarea;
				}
				
				res[i] = arrayEvalTareas;
  		}
  		
  		setEvaluacionSD( res );
		  setOAsEjecutadas( 0 );
  	}
  	
  	return ( res != undefined );
  }
  
  public function inicializaOA( oa:Number )
  {
  	var modelo:Array = _estructuraSD[ _secuencia ];
  	var i:Number = oa - 1;
		var o:Object = modelo[ i ];
		
		var nActividades:Number = o.actividades;
		var nItems:Number = o.items;
		
		var arrayEvalTareas:Array = new Array(nActividades);
		
		arrayEvalTareas.completo = false;
		arrayEvalTareas.iniciado = false;
		
		for ( var j:Number = 0; j < nActividades; j++ )
		{
			var evalTarea = new GestorEvaluacionActividad();
						
			evalTarea.introNelementos( nItems );
			evalTarea["completo"] = false;
			arrayEvalTareas[j] = evalTarea;
		}
		
		var res:Array = getEvaluacionSD();
		res[i] = arrayEvalTareas;
  }
  
  public function serializa() : String
  {
		var parser:ParserEvaluacion = new ParserEvaluacion();
    var e:Array = getEvaluacionSD();
    e.oas_ejecutadas = getOAsEjecutadas();
		var res:String = parser.serializa( e );
		
		return res;
  }

  public function deserializa( cadena:String ) : Boolean
  {
		var parser:ParserEvaluacion = new ParserEvaluacion();
		var e:Array = parser.deserializa( cadena );
		var res:Boolean = false;
		if ( e )
		{
			setEvaluacionSD( e );
			setOAsEjecutadas( e.oas_ejecutadas );
	    revisaEstadoOAs();
			res = true;
		}
		
		return res;
  }
  

  public function revisaEstadoOAs()
  {
		var n:Number = getEvaluacionSD().length;

		for ( var oa:Number = 1; oa <= n; oa++ )
		{
			revisaEstadoOA( oa );
		}
  }

  
  public function revisaEstadoOA( oa:Number )
  {
		var arrayActividades:Array = getEvaluacionOA( oa );
		var nActividades = arrayActividades.length;
		
		var completo:Boolean = true;
		for ( var i:Number = 0; i < nActividades; i++ )
		{
			completo = completo && arrayActividades[i].completo;
		}
		
		arrayActividades.completo = completo;

		if ( completo && ( oa > getOAsEjecutadas() ) )
		{
			setOAsEjecutadas( oa );
		}
  }
  
  public function getOAEstaCompleta( oa:Number ) : Boolean
  {
  	var res = getEvaluacionOA( oa ).completo;
  	return res;
  }

  public function setOAEstaCompleta( oa: Number, estado:Boolean )
  {
  	getEvaluacionOA( oa ).completo = estado;
  }

  public function getOAEstaIniciada( oa:Number ) : Boolean
  {
  	var res = getEvaluacionOA( oa ).iniciado;
  	return res;  	
  }

  public function setOAEstaIniciada( oa:Number, estado:Boolean )
  {
  	getEvaluacionOA( oa ).iniciado = estado;
  }

  public function getTareaEstaCompleta( oa:Number, actividad:Number ) : Boolean
  {
  	var res = getEvaluacionActividad( oa, actividad )[ "completo" ];
  	return res;
  }


	public function getNumeroOAs() : Number
	{
  	var modelo:Array = _estructuraSD[ _secuencia ];
  	return modelo.length;
	}

	public function getNumeroActividades( oa:Number ) : Number
	{
  	var modelo:Array = _estructuraSD[ _secuencia ];
  	return modelo[ oa - 1 ].actividades;
	}

	public function getNumeroItems( oa:Number ) : Number
	{
  	var modelo:Array = _estructuraSD[ _secuencia ];
  	return modelo[ oa - 1 ].items;
	}

	public static function test()
	{
		var g:GestorEvaluacionGlobal = new GestorEvaluacionGlobal( "04" );
		_level100.log.htmlText += "N. OAs:" + g.getNumeroOAs();
		_level100.log.htmlText += "N. Actividades(OA=2):" + g.getNumeroActividades( 2 );
		_level100.log.htmlText += "N. Items:" + g.getNumeroItems( 2 );
		
		var estado1:String = g.serializa();
		g.inicializa();
		var estado2:String = g.serializa();

		_level100.log.htmlText += "existeEvaluacion():" + g.existeEvaluacion();
		_level100.log.htmlText += "inicializa() OK?:" + ( estado1 == estado2 );
		_level100.log.htmlText += "getOAsEjecutadas():" + g.getOAsEjecutadas();
		_level100.log.htmlText += "getEvaluacionActividad(2,6).obtenerNelementos():" + g.getEvaluacionActividad(2,2).obtenerNelementos();  // 4
		
	  var gea:GestorEvaluacionActividad = new GestorEvaluacionActividad();
	  gea.introNelementos(2);
	  gea.sumarAcierto();
	  gea.sumarFallo();
	  gea[ "completo" ] = true;
	  
	  var n:Number = g.getEvaluacionOA( 2 ).length;
	  for ( var i:Number = 1; i <= n; i++ )
	  {
	  	g.setEvaluacionActividad( 2, i, gea );
			_level100.log.htmlText += "getOAEstaCompleta(2) tras cambio en item " + i + ":" + g.getOAEstaCompleta(2);
	  }
		_level100.log.htmlText += "getOAsEjecutadas():" + g.getOAsEjecutadas();
	  
	  _level100.log.htmlText += "getOAEstaIniciada(2) antes:" + g.getOAEstaIniciada(2);
	  g.setOAEstaIniciada(2, true);
	  _level100.log.htmlText += "getOAEstaIniciada(2) despus:" + g.getOAEstaIniciada(2);

	  _level100.log.htmlText += "getOAEstaCompleta(1) antes:" + g.getOAEstaCompleta(1);
	  g.setOAEstaCompleta(1, true);
	  _level100.log.htmlText += "getOAEstaCompleta(1) despus:" + g.getOAEstaCompleta(1);
	}
}