﻿
/*En esta clase se implementan los métodos necesarios para imprimir una lista de movieclips
organizarlos en páginas y darles el tamaño deseado de impresión*/

class GestorImpresion{
	
  private var tituloClip:MovieClip;
  private var arrayTitulo:Array = new Array;
	private var listaMovieClips:Array;
	private var movieClipsPorHoja:Number;
	private var columnas:Number;
	private var arrayPosiciones:Array = new Array;
	private var arrayEscalas:Array = new Array;
	private var contadorImpresos:Number = 0;
	private var contadorRestaurados:Number = 0;
	private var my_pj:PrintJob;
	private var limiteAlto:Number;
	private var limiteAncho:Number;
	private var porcentajeEscalado:Number;
	private var colocados:Number = 0;
	private var cuentas:Number = 0;
	private var ref:MovieClip;
	private var x0:Number = -1000;
	private var y0:Number = -1000;
	private var arrayTextos:Array = new Array;
		
	public function GestorImpresion (titulo:MovieClip, Clips:Array, clipsPorHoja:Number, numeroColumnas:Number ){
	/*Recibe:
		- lista de movieclips que quiere imprimir
		- número de movieclips que van a ir en cada hoja (los recibe en el orden en que van a 
		  ser impresos)
		- número de columnas en q voy a imprimir
	*/
		tituloClip = titulo;
		listaMovieClips = Clips;
		movieClipsPorHoja = clipsPorHoja;
		columnas = numeroColumnas;
		//_root.log.htmlText += "X:" + listaMovieClips[0]._x;
		//_root.log.htmlText += "Y:" + listaMovieClips[0]._y;
		//_root.log.htmlText += "W:" + listaMovieClips[0]._width + " (XS:" + listaMovieClips[0]._xscale + ")";
		//_root.log.htmlText += "H:" + listaMovieClips[0]._height + " (YS:" + listaMovieClips[0]._yscale + ")";
		ref = _root;
	}
	
	public function Imprimir(){
		trace("vamos a imprimir " + listaMovieClips[0]);

		//activa la impresión
		var pageCount:Number = 0;
	    my_pj = new PrintJob();
		if (my_pj.start())
		{
			PreparaTextos();
		
			// Almacena escalas reales, para reponerlas al final, y las deja a 100%
			PreprocesaEscalas();
			arrayTitulo[0] = tituloClip._x;
			arrayTitulo[1] = tituloClip._y;
			
			tituloClip._xscale = 150;
			tituloClip._yscale = 150;
			tituloClip._x = x0 + ( my_pj.pageWidth - tituloClip._width ) / 2;
			tituloClip._y = y0;
			
			// calcula la escala que le tiene que aplicar a cada movieClip(%)
			//genera las páginas correspondientes con los clips que le hayamos dicho del tamaño calculado
			while (contadorImpresos < listaMovieClips.length){
				var j:Number;
				calculaEscala();
				for (j=0; j<movieClipsPorHoja; j++){
					Reescalar(contadorImpresos);
					contadorImpresos++;
				}
				Colocar();


				//ref.log.htmlText += "MAX X:" + limiteAncho;
				//ref.log.htmlText += "MAX Y:" + limiteAlto;

				//if (my_pj.addPage(_root, {xMin:-500,xMax:limiteAncho,yMin:-500,yMax:limiteAlto}, {printAsBitmap:true})){
				if (my_pj.addPage(_root, {xMin:x0, xMax:my_pj.pageWidth, yMin:y0, yMax:my_pj.pageHeight}, {xprintAsBitmap:true})){
					pageCount++;
				}
				DevolverPosiciónOriginal();
				for (j=0; j<movieClipsPorHoja; j++){
					DevolverTamaño(contadorRestaurados);
					contadorRestaurados++;
				}
			}
			tituloClip._xscale = 100;
			tituloClip._yscale = 100;
			tituloClip._x = arrayTitulo[0];
			tituloClip._y = arrayTitulo[1];
	
			RecuperaTextos()

		}
		if (pageCount > 0){
			my_pj.send();
		}
		//destruye la impresión
		delete my_pj;
		
	
	}
	
	private function PreprocesaEscalas()
	{
			for ( var i:Number = 0; i < listaMovieClips.length; i++ )
			{
					var movieClipAImprimir = listaMovieClips[i];
				  arrayEscalas[i] = [movieClipAImprimir._xscale , movieClipAImprimir._yscale];
				  movieClipAImprimir._xscale = 100;
				  movieClipAImprimir._yscale = 100;
			}
	}
	
	private function PreparaTextos()
	{		
			for ( var i:Number = 0; i < 6; i++ )
			{
					var movieClipAImprimir = listaMovieClips[i*2 + 1];
				  arrayTextos[i] = movieClipAImprimir.htmlText;
				  movieClipAImprimir.text = (i + 1) + ". " + movieClipAImprimir.text;				
			}
	}

	private function RecuperaTextos()
	{		
			for ( var i:Number = 0; i < 6; i++ )
			{
					var movieClipAImprimir = listaMovieClips[i*2 + 1];
				  movieClipAImprimir.htmlText = arrayTextos[i];
			}
	}

	
	private function calculaEscala (){
		//Los elementos que me han pasado pueden variar en cuanto al alto
		var maxAnchoElem:Number;
		var EscaladoX:Number;
		var EscaladoY:Number;
		var columnasImpresion:Number;
		var primero:MovieClip;
		var suma:Number = 0;
		var j:Number;
		var r:Number;

		//ref.log.htmlText += "o:" + my_pj.orientation;
		//ref.log.htmlText += "w:" + my_pj.pageWidth;
		//ref.log.htmlText += "h:" + my_pj.pageHeight;

		var margen:Number;

		/*Tenemos una página en horizontal*/
		if (my_pj.orientation == "landscape"){
			columnasImpresion = columnas + 1;
			margen = 50;
		}
		else{
			columnasImpresion = columnas;
			margen = 30;
		}
		
		maxAnchoElem = my_pj.pageWidth/columnasImpresion;
		primero = listaMovieClips[contadorImpresos];  // Se salta el título
		EscaladoX = (maxAnchoElem/(primero._width + margen))*100;

		for (j=0; j<(movieClipsPorHoja/columnasImpresion); j++){
			if (colocados + j < listaMovieClips.length)
				suma = suma + listaMovieClips[contadorImpresos + j]._height;
		}
		
		EscaladoY = (my_pj.pageHeight/suma) * 100;
		//EscaladoY = (my_pj.pageHeight/suma) * 100;
		if (colocados + movieClipsPorHoja > listaMovieClips.length){
			porcentajeEscalado = porcentajeEscalado;
		}
		else{	
			if (EscaladoY < EscaladoX){
				porcentajeEscalado = EscaladoY;
			}
			else{
				porcentajeEscalado = EscaladoX;
			}
		}
		
		//ref.log.htmlText += "E:" + porcentajeEscalado;
	}
	
	private function Reescalar(i:Number){
		//recibe como parámetro qué elemento de la lista de movieclips que tengo para imprimir
		//voy a reescalar. (la escala se hace con un % por lo que con ponerlo a 100 al restaurarlo
		//será suficiente, no necesitamos almacenar sus valores previos)
		var movieClipAImprimir:MovieClip;
		
		movieClipAImprimir = listaMovieClips[i];
		movieClipAImprimir._xscale = porcentajeEscalado;
		movieClipAImprimir._yscale = porcentajeEscalado;
	}
	
	private function Colocar (){
		//Coloca los movieclips en una determinada zona para despues imprimir esa zona
		//en principio se van a mover a la (0,0)
		//Según sea la orientación del papel pondrá los movieclips en un orden u otro:
		//*si es vertical los pondrá uno debajo del otro
		//*si es horizontal los pondrá al lado
		//Almacena en el array de Posiciones (arrayPosiciones) las coordenadas de los clips antes 
		//de moverlos para la impresión.
		var movieClipAImprimir:MovieClip;
		var i:Number;
		var k:Number;
		var coordenadas:Array = new Array;
		trace ("BEL"+ listaMovieClips[colocados]);
		// estos son los parámetros que varían entre una y otra orientación, el resto es igual
		var fil:Number;
		var col:Number;
		var deltaY:Number;
		
		/*Esta colocada horizontalmente*/
		if (my_pj.orientation == "landscape"){
			col = ( columnas + 1 ) *2;
			fil = movieClipsPorHoja/col;
			deltaY = 120;
		}
		else{
			col = columnas * 2;
			fil = movieClipsPorHoja/col;
			deltaY = 70;
		}
			
		var elAlto = listaMovieClips[colocados]._height;
		var elAlto1 = listaMovieClips[colocados+1]._height;
		var elAncho = listaMovieClips[colocados]._width;
		var alturaSiguiente:Number = y0 + deltaY;
		var anchoSiguiente0:Number = x0 + ( my_pj.pageWidth - elAncho * col / 2 - 100 * ( col / 2 - 1 )  ) / 2;
		var anchoSiguiente:Number = anchoSiguiente0;
		
		for (k=0; k<fil; k++){
			if (colocados < listaMovieClips.length){
				anchoSiguiente = anchoSiguiente0;
				for (i=0; i<col; i++){
					if (colocados < listaMovieClips.length){
						movieClipAImprimir = listaMovieClips[colocados];
						trace("BEL: Colocar " + movieClipAImprimir + anchoSiguiente + alturaSiguiente);
						arrayPosiciones[colocados] = [movieClipAImprimir._x , movieClipAImprimir._y];
						movieClipAImprimir._x = anchoSiguiente + elAncho * 0.1;
						movieClipAImprimir._y = alturaSiguiente + ( ( i % 2 ) == 0 ? 0 : elAlto * 0.8 );
						
						if ( i % 2 == 0 )
						{
							movieClipAImprimir._xscale *= 0.8;
							movieClipAImprimir._yscale *= 0.8;
						}
						else
						{
							anchoSiguiente += elAncho + 100;
							
							movieClipAImprimir._xscale *= 0.9;
							movieClipAImprimir._yscale *= 0.9;
						}

						colocados++;
					}
				}
				
				alturaSiguiente += elAlto*0.9 + elAlto1;
			}
		}
		limiteAlto = alturaSiguiente;
		limiteAncho = anchoSiguiente;
	}
	
	private function DevolverPosiciónOriginal (movies:Array){
		//recoge del arrayPosiciones las coordenadas originales de los clips que se van a imprimir
		//y los sitúa de nuevo allí.
		var k:Number;
		var movieClipAImprimir:MovieClip;
		var coordenadas:Array;
		
		for (k = contadorImpresos - movieClipsPorHoja; k < contadorImpresos; k++){
			movieClipAImprimir = listaMovieClips[k];
			coordenadas = arrayPosiciones[k];
			movieClipAImprimir._x = coordenadas[0];
			movieClipAImprimir._y = coordenadas[1];
		}
	}
	
	private function DevolverTamaño(i:Number){
		//vuelve a dar el tamaño original a los movieclips
		var movieClipAImprimir:MovieClip;

		var escala:Array = arrayEscalas[i];

		movieClipAImprimir = listaMovieClips[i];

		movieClipAImprimir._xscale = escala[0];
		movieClipAImprimir._yscale = escala[1];	
	}
}