import configuracion.GestorSCORM;
import GestorEvaluacionGlobal;

class GestorInfoExterna
{
	//El _gestorSCORM se utilizara para la comunicacion con el LMS
	private var _gestorSCORM:GestorSCORM;
  private var _existeSCORM:Boolean;
	private var _existeInfoExterna:Boolean;

	public function GestorInfoExterna()
	{
		//Se crea un _gestorSCORM para la comunicacion con el LMS
		_gestorSCORM = new GestorSCORM();
		//Se inicia la comunicacion con el LMS si no esta establecida
		if(!_gestorSCORM.IsInitialized())
		{
			_gestorSCORM.Initialize();
		}

		if(_gestorSCORM.IsInitialized())
		{
		  var xxx;
			_existeSCORM = true;
			_existeInfoExterna = ( _gestorSCORM.GetValue("cmi.suspend_data") != 403 );
		}
		else
		{
			_existeSCORM = false;
			_existeInfoExterna = false;
		}
	}

	public function existeInfoExterna()
	{
		return _existeInfoExterna;
	}

	public function guardaInfoExterna()
	{
		if ( _existeSCORM )
		{		
			var gEvalGlobal:GestorEvaluacionGlobal = new GestorEvaluacionGlobal( _level0.secuencia );
			var estado:String = gEvalGlobal.serializa();
			
			var info = _level0.stringConfiguracion + "<evaluacion>" + estado + "</evaluacion>";

			_gestorSCORM.SetValue("cmi.suspend_data", info);
			_gestorSCORM.Commit();
			_existeInfoExterna = true;
		}
	}
	
	public function leeInfoExterna() : String
	{
		var res:String = undefined;
		
		if ( _existeSCORM && _existeInfoExterna )
		{		
			var cadena:String = _gestorSCORM.GetValue("cmi.suspend_data");

			var i:Number = cadena.indexOf( "<evaluacion>" );
			var j:Number = cadena.indexOf( "</evaluacion>" );
			if ( ( i >= 0 ) && ( j >= 0 ) )
			{
				var configuracion = cadena.substring( 0, i );
				var estado = cadena.substring( i + 12, j );
				
				var gEvalGlobal:GestorEvaluacionGlobal = new GestorEvaluacionGlobal( _level0.secuencia );
				gEvalGlobal.deserializa( estado );
								
				res = configuracion;
			}
		}
		else
		{
			var gEvalGlobal:GestorEvaluacionGlobal = new GestorEvaluacionGlobal( _level0.secuencia );
			
			//_level100.log.htmlText += "E:" + gEvalGlobal.existeEvaluacion() + " " + _level0.secuencia;
			//_level100.log.htmlText += "OAS_ejecutadas:" + gEvalGlobal.getOAsEjecutadas() + " " + typeof _level0.oas_ejecutadas;
			
			if ( !gEvalGlobal.existeEvaluacion() )
			{
				gEvalGlobal.inicializa();
			}
			//_level100.log.htmlText += "OAS_ejecutadas:" + gEvalGlobal.getOAsEjecutadas() + " " + typeof _level0.oas_ejecutadas;
			
			res = _level0.stringConfiguracion;
		}
		
		return res;
	}
}