﻿//Clase Herramienta Bocadillo
//Autora: Belén Ríos Sánchez

/*Esta clase deriva de la herramienta sello, puesto un bocadillo es un sello
en el que además se puede escribir*/

/*Los tipos de bocadillos que tenemos son:
- HABLAR: Con el identificador Img_26_25 en el fla;
- PENSAR: Con el identificador Img_26_26 en el fla;

NO SE PUEDE PONER COMO BOCADILLO OTRO MOVIECLIP, ya que es NECESARIO QUE INCLUYA DENTRO UN CUADRO DE TEXTO
que se debe llamar obligatoriamente textoBocadillo
*/

import mx.utils.Delegate;
import HerramientaTexto;
import Lienzo;
import HerramientaReedicion;

class HerramientaBocadillo extends HerramientaSello {
	private var xBocadillo:Number;
	private var yBocadillo:Number;
	private var anchoBocadillo:Number;
	private var altoBocadillo:Number;
	private var areaTexto:MovieClip;
	private var numeroHerramientaTexto:Number;
	private var nombreBocadillo:String;
	private var hTexto:HerramientaTexto;
	private var hReedicion:HerramientaReedicion;
	private var nombreInstancia:String;
	private var reeditando:Boolean = false;

	function HerramientaBocadillo(bocadillo:String, numeroHT:Number, ancho:Number, alto:Number, hReed:HerramientaReedicion, nInst:String) {
		super(bocadillo);
		nombreBocadillo = bocadillo;
		anchoBocadillo = ancho;
		altoBocadillo = alto;
		numeroHerramientaTexto = numeroHT;
		hReedicion = new HerramientaReedicion();
		hReedicion = hReed;
		//el nombre que hemos dado a esta instancia en el .fla que le llama.
		nombreInstancia = nInst;
	}
	
	function inicializarPintado(xInic:Number, yInic:Number, li:MovieClip) {
		trace("inicializa");
		//super(li);
		_root.anularHerramientas ();
		_root.bocadillosPuestos = _root.bocadillosPuestos + 1;
		xInicial = xInic;
		yInicial = yInic;
		lienzo = li;
		lienzo.sello.removeMovieClip();
		sello = lienzo.attachMovie(SelloAInstanciar, "sello", lienzo.getNextHighestDepth());
		lienzo.sello._x = xInicial;
		lienzo.sello._y = yInicial;
		lienzo.sello._width = anchoBocadillo;
		lienzo.sello._height = altoBocadillo;
		lienzo.desactivar = true;
		lienzo.pintando = false;
		var temp:Lienzo = Lienzo(lienzo);
		if (temp) {
			temp.desactivarLienzoTecladoActivo();
		}
		ampliarBocadillo();
	}
	
	private function ampliarBocadillo() {
		trace("BEL: amplia");
		//recojo los parámetros actuales del bocadillo para poder restaurarlos después.
		xBocadillo = sello._x;
		yBocadillo = sello._y;
		//le doy su nueva posición y su nuevo tamaño
		sello._x = 10;
		sello._y = 15;
		sello._height = 60;
		sello._width = 60;
		sello.textoBocadillo._x = 20;
		sello.textoBocadillo._y = 25;
		sello.textoBocadillo._height = 300;
		sello.textoBocadillo._width = 115;
		sello.setFocus();
		if (hTexto==undefined)
			hTexto = new HerramientaTexto(135, 105, 50, 18, sello, true, true);
		hTexto.activarRegion(numeroHerramientaTexto, sello);
	}

	function finalizarPintado() {
		//super(lienzo);
		trace("finaliza" + hReedicion);
		var nombre:String = "bocadillo"+numeroHerramientaTexto;
		sello._x = xBocadillo;
		sello._y = yBocadillo;
		
		hTexto.desactivarRegion();

		lienzo.sello.duplicateMovieClip(nombre,lienzo.getNextHighestDepth(),{_width:anchoBocadillo, _height:altoBocadillo});
		lienzo[nombre].textoBocadillo.text = lienzo.sello.textoBocadillo.text;
		lienzo.sello.removeMovieClip();
		lienzo.desactivar = false;
		
		_root.gAcces.gGrupos.insertar(lienzo[nombre], "edicionpaleta");
		
		if (reeditando == false)
			hReedicion.AñadirElemento(lienzo["bocadillo"+numeroHerramientaTexto], nombreInstancia);				
		reeditando = true;
	}


	
	public function reeditarBocadillo(boc:MovieClip){
		_root.anularHerramientas();
		lienzo.sello.removeMovieClip();
		sello = lienzo.attachMovie(SelloAInstanciar, "sello", lienzo.getNextHighestDepth());
		sello.textoBocadillo.text = boc.textoBocadillo.text;
		sello._x = boc._x;
		sello._y = boc._y;
		boc.removeMovieClip();
		lienzo.desactivar = true;
		lienzo.pintando = false;
		var temp:Lienzo = Lienzo(lienzo);
		if (temp) {
			temp.desactivarLienzoTecladoActivo();
			temp.herramientaUtilizada = _root["herramientaBocadillo"+numeroHerramientaTexto];
		}
		ampliarBocadillo();
	}

	function dameInformacionCursor():Array {
		trace("dameInformacionCursor");
		/*Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		En este caso el cursor que voy a instanciar va a ser el propio bocadillo
		*/
		var infoCursor:Array = new Array(nombreBocadillo, "CursorBocadillo");
		return infoCursor;
	}// FIN dameInformacionCursor
}