﻿//Clase Herramienta Círculo
//Autora: Belén Ríos Sánchez
//En esta clase se implementan los métodos de herramienta para dibujar círculos

class HerramientaCirculo implements Herramienta{

	private var circulo:MovieClip;
	private var colorCirculo:Number;
	private var alfaCirculo:Number;
	private var xInicial:Number;
	private var yInicial:Number;
	private var radio: Number;
	private var lienzo:MovieClip;
	
	public function HerramientaCirculo(color:Number, alfa:Number){
		// asignamos los parametros recibidos, a los atributos de la clase
		colorCirculo = color;
		alfaCirculo = alfa;
	}//FIN Constructor de la herramienta círculo
	
	function inicializarPintado(xInic:Number, yInic:Number, li:MovieClip){
		trace("inicializarPintado");
		/*Se activa la herramienta círculo instanciando un nuevo movieclip */
		xInicial = xInic;
		yInicial = yInic;
		lienzo = li;
	}
	
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean){
		trace("pintar");
		/*Pintamos un nuevo círculo siempre y cuando el nuevo radio lo mantenga dentro del lienzo*/
		var radio:Number; // radio local para pintar
		var radio2:Number; //radio global para saber si está dentro del lienzo el nuevo circulo
		var Cursor2: Object = new Object;
		var Cursor3: Object = new Object;
		
		Cursor2.x = nueva_x;
		Cursor2.y = nueva_y;
		lienzo.localToGlobal(Cursor2);

		Cursor3.x = xInicial;
		Cursor3.y = yInicial;
		lienzo.localToGlobal(Cursor3);
		
		radio = calculaRadio(xInicial, yInicial, nueva_x, nueva_y);	
		radio2 = calculaRadio(Cursor3.x, Cursor3.y, Cursor2.x, Cursor2.y);

		if (lienzo.hitTest(Cursor3.x+radio2,Cursor3.y+radio2) && 
			lienzo.hitTest(Cursor3.x-radio2,Cursor3.y-radio2)){
			lienzo.circulo.removeMovieClip();
			//creamos el movieclip círculo q vamos a pintar
			lienzo.createEmptyMovieClip("circulo", lienzo.getNextHighestDepth());
			//circulo = this.attachMovie("Símbolo5", "circulo",this.getNextHighestDepth());
			dibujaCirculo(lienzo.circulo, radio, colorCirculo, alfaCirculo)
		}
	}

	private function calculaRadio(xinicio:Number, yinicio:Number, xfin:Number, yfin:Number):Number{
		var incx:Number;
		var incy:Number;
		incx = xfin - xinicio;
		incy = yfin - yinicio;
		radio = incx*incx + incy*incy;
		radio = Math.sqrt(radio);
		return radio;
	}
	
	private function dibujaCirculo(circulo:MovieClip, rad:Number, colorRelleno:Number, transparencia:Number):Void {
		trace("dibujaCirculo");
		var x:Number = xInicial;
		var y:Number = yInicial;

		with (circulo){
			beginFill(colorRelleno, transparencia); 
			moveTo(x + rad, y);
			curveTo(rad + x, Math.tan(Math.PI / 8) * rad + y, Math.sin(Math.PI / 4) * rad + x, Math.sin(Math.PI / 4) * rad + y);
			curveTo(Math.tan(Math.PI / 8) * rad + x, rad + y, x, rad + y);
			curveTo(-Math.tan(Math.PI / 8) * rad + x, rad+ y, -Math.sin(Math.PI / 4) * rad + x, Math.sin(Math.PI / 4) * rad + y);
			curveTo(-rad + x, Math.tan(Math.PI / 8) * rad + y, -rad + x, y);
			curveTo(-rad + x, -Math.tan(Math.PI / 8) * rad + y, -Math.sin(Math.PI / 4) * rad + x, -Math.sin(Math.PI / 4) * rad + y);
			curveTo(-Math.tan(Math.PI / 8) * rad + x, -rad + y, x, -rad + y);
			curveTo(Math.tan(Math.PI / 8) * rad + x, -rad + y, Math.sin(Math.PI / 4) * rad + x, -Math.sin(Math.PI / 4) * rad + y);
			curveTo(rad + x, -Math.tan(Math.PI / 8) * rad + y, rad + x, y);
			endFill();
		}
	}
	
	function finalizarPintado(){
		trace("finalizarPintado");
		/*Desactivamos el pintado. Fijamos la línea con la que estabamos trabajando*/
		lienzo.circulo.duplicateMovieClip("nuevocirculo", lienzo.getNextHighestDepth());
	}
	
	function dameInformacionCursor():Array{
		trace("dameInformacionCursor");
	/*	Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		CursorAInstanciar = "Símbolo 4"; // nombre en la biblioteca del fla
		NombreCursorAInstanciar = "CursorFormas";
	*/		
		var infoCursor: Array = new Array ("Símbolo 4", "CursorFormas");
		return infoCursor;
	}// FIN dameInformacionCursor	
}//FIN HerramientaCirculo