﻿//Clase Herramienta Cuadrado
//Autora: Belén Ríos Sánchez
//En esta clase se implementan los métodos de herramienta para dibujar cuadrados
//si x e y son distintas, se hará de lado = a la mas pequeña de las dos

class HerramientaCuadrado implements Herramienta{

	private var cuadrado:MovieClip;
	private var colorCuadrado:Number;
	private var alfaCuadrado:Number;
	private var xInicial:Number;
	private var yInicial:Number;
	private var lienzo:MovieClip;
	
	public function HerramientaCuadrado(color:Number, alfa:Number){
		// asignamos los parametros recibidos, a los atributos de la clase
		colorCuadrado = color;
		alfaCuadrado = alfa;
	}//FIN Constructor de la herramienta triángulo
	
	function inicializarPintado(xInic:Number, yInic:Number, li:MovieClip){
		trace("inicializarPintado");
		/*Se activa la herramienta rectángulo instanciando un nuevo movieclip */
		xInicial = xInic;
		yInicial = yInic;
		lienzo = li;
	}
	
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean){
		trace("pintar");
		/*Pintamos un nuevo cuadrado con el nuevo tamaño borrando el anterior*/
		var ancho:Number = nueva_x - xInicial;
		var alto:Number = nueva_y - yInicial;

		lienzo.cuadrado.removeMovieClip();
		//creamos el movieclip cuadrado q vamos a pintar
		lienzo.createEmptyMovieClip("cuadrado", lienzo.getNextHighestDepth());
		lienzo.cuadrado._x = xInicial;
		lienzo.cuadrado._y = yInicial;
		if (ancho < alto)
			dibujaRectangulo(lienzo.cuadrado, ancho, ancho, colorCuadrado, 100);
		else
			dibujaRectangulo(lienzo.cuadrado, alto, alto, colorCuadrado, 100);
	}
	
	private function dibujaRectangulo(rectangulo:MovieClip, ancho:Number, alto:Number, colorRelleno:Number,
							  transparencia:Number):Void {
		with (rectangulo) {
			beginFill(colorRelleno, transparencia);
			moveTo(0, 0);
			lineTo(ancho, 0);
			lineTo(ancho, alto);
			lineTo(0, alto);
			lineTo(0, 0);
			endFill();
		}
	}
	
	function finalizarPintado(){
		trace("finalizarPintado");
		/*Desactivamos el pintado. Fijamos la línea con la que estabamos trabajando*/
		lienzo.cuadrado.duplicateMovieClip("nuevocuadrado", lienzo.getNextHighestDepth());
	}
	
	function dameInformacionCursor():Array{
		trace("dameInformacionCursor");
	/*	Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		CursorAInstanciar = "Símbolo 4"; // nombre en la biblioteca del fla
		NombreCursorAInstanciar = "CursorFormas";
	*/		
		var infoCursor: Array = new Array ("Símbolo 4", "CursorFormas");
		return infoCursor;
	}// FIN dameInformacionCursor	
}//FIN HerramientaTriangulo