﻿//Clase Herramienta Texto
//Autora: Belén Ríos Sánchez

/*En esta clase se implementan los métodos necesarios para imprimir una lista de movieclips
organizarlos en páginas y darles el tamaño deseado de impresión*/

class HerramientaImpresion{
	
	private var listaMovieClips:Array;
	private var movieClipsPorHoja:Number;
	private var columnas:Number;
	private var arrayPosiciones:Array = new Array;
	private var contadorImpresos:Number = 0;
	private var contadorRestaurados:Number = 0;
	private var my_pj:PrintJob;
	private var limiteAlto:Number;
	private var limiteAncho:Number;
	private var porcentajeEscalado:Number;
	private var colocados:Number = 0;
	private var cuentas:Number = 0;
		
	public function HerramientaImpresion (Clips:Array, clipsPorHoja:Number, numeroColumnas:Number){
	/*Recibe:
		- lista de movieclips que quiere imprimir
		- número de movieclips que van a ir en cada hoja (los recibe en el orden en que van a 
		  ser impresos)
		- número de columnas en q voy a imprimir
	*/
		listaMovieClips = Clips;
		movieClipsPorHoja = clipsPorHoja;
		columnas = numeroColumnas;
	}

	public function Imprimir(){
		trace("vamos a imprimir " + listaMovieClips[0]);
		
		//activa la impresión
		var pageCount:Number = 0;
	    my_pj = new PrintJob();
		if (my_pj.start())
		{
			// calcula la escala que le tiene que aplicar a cada movieClip(%)
			//genera las páginas correspondientes con los clips que le hayamos dicho del tamaño calculado
			while (contadorImpresos < listaMovieClips.length){
				var j:Number;
				calculaEscala();
				for (j=0; j<movieClipsPorHoja; j++){
					Reescalar(contadorImpresos);
					contadorImpresos++;
				}
				Colocar();
				if (my_pj.addPage(_root, {xMin:-500,xMax:limiteAncho,yMin:-500,yMax:limiteAlto})){
					pageCount++;
				}
				DevolverPosiciónOriginal();
				for (j=0; j<movieClipsPorHoja; j++){
					DevolverTamaño(contadorRestaurados);
					contadorRestaurados++;
				}
			}
		}
		if (pageCount > 0){
			my_pj.send();
		}
		//destruye la impresión
		delete my_pj;
	}
	
	private function calculaEscala (){
		//Los elementos que me han pasado pueden variar en cuanto al alto
		var maxAnchoElem:Number;
		var EscaladoX:Number;
		var EscaladoY:Number;
		var columnasImpresion:Number;
		var primero:MovieClip;
		var suma:Number = 0;
		var j:Number;
		var r:Number;

		/*Tenemos una página en horizontal*/
		if (my_pj.orientation == "landscape"){
			columnasImpresion = columnas*2;
		}
		else{
			columnasImpresion = columnas;
		}
		maxAnchoElem = my_pj.pageWidth/columnasImpresion;
		primero = listaMovieClips[contadorImpresos];
		EscaladoX = (maxAnchoElem/primero._width)*100

		for (j=0; j<(movieClipsPorHoja/columnasImpresion); j++){
			if (colocados + j < listaMovieClips.length)
				suma = suma + listaMovieClips[contadorImpresos + j]._height;
		}
		
		EscaladoY = (my_pj.pageHeight/suma) * 100;
		if (colocados + movieClipsPorHoja > listaMovieClips.length){
			porcentajeEscalado = porcentajeEscalado;
		}
		else{	
			if (EscaladoY < EscaladoX){
				porcentajeEscalado = EscaladoY;
			}
			else{
				porcentajeEscalado = EscaladoX;
			}
		}
	}
	
	private function Reescalar(i:Number){
		//recibe como parámetro qué elemento de la lista de movieclips que tengo para imprimir
		//voy a reescalar. (la escala se hace con un % por lo que con ponerlo a 100 al restaurarlo
		//será suficiente, no necesitamos almacenar sus valores previos)
		var movieClipAImprimir:MovieClip;
		
		movieClipAImprimir = listaMovieClips[i];
		movieClipAImprimir._xscale = porcentajeEscalado;
		movieClipAImprimir._yscale = porcentajeEscalado;
	}
	
	private function Colocar (){
		//Coloca los movieclips en una determinada zona para despues imprimir esa zona
		//en principio se van a mover a la (0,0)
		//Según sea la orientación del papel pondrá los movieclips en un orden u otro:
		//*si es vertical los pondrá uno debajo del otro
		//*si es horizontal los pondrá al lado
		//Almacena en el array de Posiciones (arrayPosiciones) las coordenadas de los clips antes 
		//de moverlos para la impresión.
		var movieClipAImprimir:MovieClip;
		var i:Number;
		var k:Number;
		var alturaSiguiente:Number = -500;
		var anchoSiguiente:Number = -500;
		var coordenadas:Array = new Array;
		trace ("BEL"+ listaMovieClips[colocados]);
		// estos son los parámetros que varían entre una y otra orientación, el resto es igual
		var fil:Number;
		var col:Number;
		/*Esta colocada horizontalmente*/
		if (my_pj.orientation == "landscape"){
			col = columnas * 2;
			fil = movieClipsPorHoja/col;
		}
		else{
			col = columnas;
			fil = movieClipsPorHoja/col;
		}
			
		for (i=0; i<col; i++){
			if (colocados < listaMovieClips.length){
				alturaSiguiente = -500;
				for (k=0; k<fil; k++){
					if (colocados < listaMovieClips.length){
						movieClipAImprimir = listaMovieClips[colocados];
						trace("BEL: Colocar " + movieClipAImprimir + anchoSiguiente + alturaSiguiente);
						arrayPosiciones[colocados] = [movieClipAImprimir._x , movieClipAImprimir._y];
						movieClipAImprimir._x = anchoSiguiente;
						movieClipAImprimir._y = alturaSiguiente;
						alturaSiguiente = alturaSiguiente + movieClipAImprimir._height;
						colocados++;
					}
				}
				anchoSiguiente = anchoSiguiente + movieClipAImprimir._width;
			}
		}
		limiteAlto = alturaSiguiente;
		limiteAncho = anchoSiguiente;
	}
	
	private function DevolverPosiciónOriginal (movies:Array){
		//recoge del arrayPosiciones las coordenadas originales de los clips que se van a imprimir
		//y los sitúa de nuevo allí.
		var k:Number;
		var movieClipAImprimir:MovieClip;
		var coordenadas:Array;
		
		for (k = contadorImpresos - movieClipsPorHoja; k < contadorImpresos; k++){
			movieClipAImprimir = listaMovieClips[k];
			coordenadas = arrayPosiciones[k];
			movieClipAImprimir._x = coordenadas[0];
			movieClipAImprimir._y = coordenadas[1];
		}
	}
	
	private function DevolverTamaño(i:Number){
		//vuelve a dar el tamaño original a los movieclips
		var movieClipAImprimir:MovieClip;
		
		movieClipAImprimir = listaMovieClips[i];

		movieClipAImprimir._xscale = 100;
		movieClipAImprimir._yscale = 100;	
	}
}