﻿//Clase Herramienta Lápiz
//Autora: Belén Ríos Sánchez
//En esta clase se implementan los métodos de herramienta para dibujar 
//"a mano alzada" como si de un lápiz se tratase.

class HerramientaLapiz implements Herramienta{

	private var lapiz:MovieClip;
	private var grosorLinea:Number;
	private var colorLinea:Number;
	private var alfaLinea:Number;
	private var lienzo:MovieClip;
	private var goma:Boolean;
	
	public function HerramientaLapiz(grosor:Number, color:Number, alfa:Number, go:Boolean){
		// asignamos los parametros recibidos, a los atributos de la clase
		grosorLinea = grosor;
		colorLinea = color;
		alfaLinea = alfa;
		goma = go;
	}//FIN Constructor de la herramienta lápiz
	
	function inicializarPintado(xInicial:Number, yInicial:Number, li:MovieClip){
		trace("inicializarPintado");
		/*Se activa la herramienta lápiz instanciando un nuevo movieclip que será la linea
		en la posición que recibimos como parámetro*/
		trace(lienzo);
		lienzo = li;
		lienzo.lapiz.removeMovieClip();
		lienzo.createEmptyMovieClip("lapiz",lienzo.getNextHighestDepth());
		trace (lienzo.lapiz);
		lienzo.lapiz.moveTo(xInicial, yInicial);
	}
	
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean){
		trace("pintar");
		/*Desplazamos la línea que estamos pintando hasta las nuevas coordenadas que recibimos
		 y controlamos debidamente el booleano que nos indica si nos habíamos salido mientras pintabamos*/
		if (meSaliPintando == true){
			lienzo.lapiz.moveTo(nueva_x, nueva_y);
		}
		else{
			lienzo.lapiz.lineStyle(grosorLinea, colorLinea, alfaLinea);
			lienzo.lapiz.lineTo(nueva_x, nueva_y);
		}
	}
	
	function finalizarPintado(){
		trace("finalizarPintado");
		/*Desactivamos el pintado. Fijamos la línea con la que estabamos trabajando*/
		lienzo.lapiz.duplicateMovieClip("nuevolapiz", lienzo.getNextHighestDepth());
	}
	
	function dameInformacionCursor():Array{
		trace("dameInformacionCursor");
	/*	Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		CursorAInstanciar = "Símbolo 3"; // nombre en la biblioteca del fla
		NombreCursorAInstanciar = "CursorLápiz";
	*/	
		if (goma)
			var infoCursor: Array = new Array ("Símbolo 5", "CursorGoma");
		else
			var infoCursor: Array = new Array ("Símbolo 3", "CursorLápiz");
		return infoCursor;
	}// FIN dameInformacionCursor	
}//FIN HerramientaLapiz