﻿//Clase Herramienta Rectángulo
//Autora: Belén Ríos Sánchez
//En esta clase se implementan los métodos de herramienta para dibujar rectángulos

class HerramientaRectangulo implements Herramienta{

	private var rectangulo:MovieClip;
	private var colorRectangulo:Number;
	private var alfaRectangulo:Number;
	private var xInicial:Number;
	private var yInicial:Number;
	private var lienzo:MovieClip;
	
	public function HerramientaRectangulo(color:Number, alfa:Number){
		// asignamos los parametros recibidos, a los atributos de la clase
		colorRectangulo = color;
		alfaRectangulo = alfa;
	}//FIN Constructor de la herramienta rectángulo
	
	function inicializarPintado(xInic:Number, yInic:Number, li:MovieClip){
		trace("inicializarPintado");
		/*Se activa la herramienta rectángulo instanciando un nuevo movieclip */
		xInicial = xInic;
		yInicial = yInic;
		lienzo = li;
	}
	
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean){
		trace("pintar");
		/*Pintamos un nuevo rectángulo con el nuevo tamaño borrando el anterior*/
		lienzo.rectangulo.removeMovieClip();
		lienzo.createEmptyMovieClip("rectangulo", lienzo.getNextHighestDepth());
		trace("esta dentro")
		lienzo.rectangulo._x = xInicial;
		lienzo.rectangulo._y = yInicial;
		dibujaRectangulo(lienzo.rectangulo, nueva_x - xInicial, nueva_y - yInicial, colorRectangulo, alfaRectangulo);
	}
	
	private function dibujaRectangulo(rectangulo:MovieClip, ancho:Number, alto:Number, colorRelleno:Number,
							  transparencia:Number):Void {
		with (rectangulo) {
			beginFill(colorRelleno, transparencia);
			moveTo(0, 0);
			lineTo(ancho, 0);
			lineTo(ancho, alto);
			lineTo(0, alto);
			lineTo(0, 0);
			endFill();
		}
	}

	function finalizarPintado(){
		trace("finalizarPintado");
		/*Desactivamos el pintado. Fijamos la línea con la que estabamos trabajando*/
		lienzo.rectangulo.duplicateMovieClip("nuevorectangulo", lienzo.getNextHighestDepth());
	}
	
	function dameInformacionCursor():Array{
		trace("dameInformacionCursor");
	/*	Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		CursorAInstanciar = "Símbolo 4"; // nombre en la biblioteca del fla
		NombreCursorAInstanciar = "CursorFormas";
	*/		
		var infoCursor: Array = new Array ("Símbolo 4", "CursorFormas");
		return infoCursor;
	}// FIN dameInformacionCursor	
}//FIN HerramientaRectángulo