﻿//Clase Herramienta Cuadrado
//Autora: Belén Ríos Sánchez
//En esta clase se implementan los métodos de herramienta para poner dibujos predefinidos
//como si de sellos se tratase.

//la implementación se ha realizado de forma que al pulsar la primera vez se establece el inicio del sello
// segun se va moviendo varía su tamaño y al pulsar una segunda vez se fija en el lienzo.

class HerramientaSello implements Herramienta{

	private var sello:MovieClip;
	private var xInicial:Number;
	private var yInicial:Number;
	private var SelloAInstanciar:String;
	private var lienzo:MovieClip
	private static var contadorSellos:Number = 0;
	
	public function HerramientaSello(Sello:String){
		SelloAInstanciar = Sello;
	}//FIN Constructor de la herramienta triángulo
	
	function inicializarPintado(xInic:Number, yInic:Number, li:MovieClip){
		trace("inicializarPintado");
		/*Se activa la herramienta rectángulo instanciando un nuevo movieclip */
		xInicial = xInic;
		yInicial = yInic;
		lienzo = li;
	}
	
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean){
		trace("pintar");
		/*Pintamos un nuevo sello con el nuevo tamaño indicado y borramos el anterior*/

		lienzo.sello.removeMovieClip();
		//creamos el movieclip cuadrado q vamos a pintar
		sello = lienzo.attachMovie(SelloAInstanciar, "sello",lienzo.getNextHighestDepth());
		lienzo.sello._x = xInicial;
		lienzo.sello._y = yInicial;
		if ((nueva_y - yInicial >= 0) and (nueva_x - xInicial >= 0)){
			lienzo.sello._height = nueva_y - yInicial;
			lienzo.sello._width = nueva_x - xInicial;
		}
		else{
			lienzo.sello._height = 0;
			lienzo.sello._width = 0;
		}
	}
	
	
	function finalizarPintado(){
		trace("finalizarPintado");
		/*Desactivamos el pintado. Fijamos la línea con la que estabamos trabajando*/
		lienzo.sello.duplicateMovieClip("nuevosello"+contadorSellos, lienzo.getNextHighestDepth());
		contadorSellos++;
		trace("BEL: contadorSellos" + contadorSellos);
	}
	
	function dameInformacionCursor():Array{
		trace("dameInformacionCursor");
	/*	Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		CursorAInstanciar = "Símbolo 4"; // nombre en la biblioteca del fla
		NombreCursorAInstanciar = "CursorFormas";
	*/		
		var infoCursor: Array = new Array ("Símbolo 4", "CursorSello");
		return infoCursor;
	}// FIN dameInformacionCursor	
}//FIN HerramientaSello