﻿//Clase Herramienta Texto
//Autora: Belén Ríos Sánchez

/*En esta clase se recogen los métodos necesarios para escribir y dejar de escribir en un determinado
cuadro de texto que recibe como parámetro*/

class HerramientaTexto{
	
	private var ancho:Number; //ancho del cuadro de texto que voy a crear para poder escribir
	private var alto:Number;
	private var maxCaracteres:Number;//numero de caracteres máximo que se puede escribir
	private var tamañoLetra:Number;//tamaño de letra con la que vamos a escribir
	private var texto:MovieClip;//movieClip sobre el que han pulsado para escribir y que será en el que
								//despues fije el texto que me han introducido.
	private var areaEscritura:MovieClip;//area de escritura interactiva que voy a crearme.
	private var bocadillo:Boolean;
	private var multilinea:Boolean;
	
	public function HerramientaTexto (an:Number, al:Number, maxC:Number, tamL:Number, tex:MovieClip, boc:Boolean, multi:Boolean){
		ancho = an;
		alto = al;
		maxCaracteres = maxC;//numero de caracteres máximo que se puede escribir
		tamañoLetra = tamL;//tamaño de letra con la que vamos a escribir
		texto = tex;
		bocadillo = boc;
		multilinea = multi;
	}
/*	function inicializarPintado(xInicial:Number, yInicial:Number, lienzo:MovieClip){
	}
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean, lienzo:MovieClip){}
	function finalizarPintado(lienzo:MovieClip){}
	function dameInformacionCursor():Array{
		return null;
	}*/
	
	public function activarRegion (i:Number, sello:MovieClip){
		
		if (sello!=undefined)
			texto = sello;
		//hacemos que las coordenadas del texto ahora sean referentes al todo
		//no al movieclip q lo contiene.
		var obj:Object = new Object;
		obj.x = texto._x;
		obj.y = texto._y;
		texto._parent.localToGlobal(obj);
		//creamos el area para escribir
		if (areaEscritura == undefined){
			if (multilinea)
				areaEscritura = _root.attachMovie("TextArea", "areaEscritura"+i,_root.getNextHighestDepth());
			else
				areaEscritura = _root.attachMovie("TextInput", "areaEscritura"+i,_root.getNextHighestDepth());
		}
		//establecemos sus atributos
		areaEscritura._x = obj.x;
		areaEscritura._y = obj.y;
		//Si es el bocadillo, como es redondeado, no hay que poner el cuadro de texto justo al borde
		//si no adaptarlo al interior de la elipse
		if (bocadillo){
			areaEscritura._x = areaEscritura._x + 20;
			areaEscritura._y = areaEscritura._y + 15;
/*			if (texto.textoBocadillo.text == undefined){
				areaEscritura.text = "";
			}
			else{
				areaEscritura.text = texto.textoBocadillo.text;
				trace("Estoy entrando por aquí" + areaEscritura.text);
			}*/
		}

		//le damos el foco
		areaEscritura.setFocus();

		areaEscritura.enabled  = true;
		areaEscritura.vScrollPolicy = false;
		areaEscritura.hScrollPolicy = false;
		areaEscritura.wordWrap = true;
		areaEscritura.maxChars = maxCaracteres;
		areaEscritura.setStyle("fontSize", tamañoLetra);
		areaEscritura.setSize(ancho,alto);
		areaEscritura.visible = true;
		areaEscritura.setFocus();
	}
	
	 public function desactivarRegion (){
		 trace ("desactivarregion");
		//recoge el texto que hemos escrito en area
		//y lo fija en el campo de texto que le indicamos, que no es editable.
		texto.textoBocadillo.text = areaEscritura.text;
		trace("area.text" + areaEscritura + areaEscritura.text);
		areaEscritura.enabled = false;
		areaEscritura.visible = false;	
		//areaEscritura.removeMovieClip();
	}
	
	public function resetearTexto (){
		areaEscritura.text = "";
	}
}