﻿//Clase Herramienta Triángulo
//Autora: Belén Ríos Sánchez
//En esta clase se implementan los métodos de herramienta para dibujar triángulos

class HerramientaTriangulo implements Herramienta{

	private var triangulo:MovieClip;
	private var colorTriangulo:Number;
	private var alfaTriangulo:Number;
	private var xInicial:Number;
	private var yInicial:Number;
	private var lienzo:MovieClip;

	
	public function HerramientaTriangulo(color:Number, alfa:Number){
		// asignamos los parametros recibidos, a los atributos de la clase
		colorTriangulo = color;
		alfaTriangulo = alfa;
	}//FIN Constructor de la herramienta triángulo
	
	function inicializarPintado(xInic:Number, yInic:Number, li:MovieClip){
		trace("inicializarPintado");
		/*Se activa la herramienta rectángulo instanciando un nuevo movieclip */
		xInicial = xInic;
		yInicial = yInic;
		lienzo = li;
	}
	
	function pintar(nueva_x:Number, nueva_y:Number, meSaliPintando:Boolean){
		trace("pintar");
		/*Pintamos un nuevo triángulo con el nuevo tamaño borrando el anterior*/
		lienzo.triangulo.removeMovieClip();
		lienzo.createEmptyMovieClip("triangulo", lienzo.getNextHighestDepth());
		//lienzo.triangulo._x = xInicial;
		//lienzo.triangulo._y = yInicial;
		dibujaTriangulo(lienzo.triangulo, xInicial, yInicial, nueva_x, nueva_y, colorTriangulo, 100);
	}
	
	function dibujaTriangulo(triangulo:MovieClip, xI:Number, yI:Number, xF:Number, yF:Number,
							  colorRelleno:Number, transparencia:Number):Void {
		var puntoMedio:Number;
		
		puntoMedio = xI + (xF - xI)/2;
		with (triangulo) {
			beginFill(colorRelleno, transparencia);
			moveTo(xI,yF);
			lineTo(puntoMedio,yI);
			lineTo(xF,yF);
			lineTo(xI,yF)
			endFill();
		}
	}

	function finalizarPintado(){
		trace("finalizarPintado");
		/*Desactivamos el pintado. Fijamos la línea con la que estabamos trabajando*/
		lienzo.triangulo.duplicateMovieClip("nuevotriangulo", lienzo.getNextHighestDepth());
	}
	
	function dameInformacionCursor():Array{
		trace("dameInformacionCursor");
	/*	Esta función pasa los datos del cursor al lienzo. Si quisieramos que fueran variables 
		y poder cambiarlos dependiendo del .fla podríamos hacer una función EstablecerParametrosCursor.
		CursorAInstanciar = "Símbolo 4"; // nombre en la biblioteca del fla
		NombreCursorAInstanciar = "CursorFormas";
	*/		
		var infoCursor: Array = new Array ("Símbolo 4", "CursorFormas");
		return infoCursor;
	}// FIN dameInformacionCursor	
}//FIN HerramientaTriangulo