﻿/* En este archivo se recoge la implementación de algunas herramientas de dibujo*/
/* Estas herramientas son:
-lápiz
-formas geométricas
-texto
-arrastrar símbolo
-guardar
-imprimir */

import mx.utils.Delegate;

class HerramientasDibujo extends MovieClip{

	//movieclip sobre el que vamos a pintar
	private var Cursor:MovieClip;//Cursor que instanciaré e iré moviendo x el lienzo.
	private var velocidad:Number;//velocidad a la que se mueve el cursor por la pantalla(para el teclado)

	private var tecla:Number;
	
	private var altoLienzo:Number;//valores iniciales del lienzo.
	private var anchoLienzo:Number;
	private var xlienzo:Number;
	private var ylienzo:Number;
	
	private var hayCursor:Boolean=false;//cuando instancio el cursor la pongo a true, y cuando lo borro a false
	
	private var pintandoConTeclado:Boolean = false;//me permite saber si estoy pintando una línea con teclado o con ratón

	private var CursorAInstanciar:String;//esta variable contiene el símbolo de la librería asociado al cursor correspondiente a la herramienta con la que estoy trabajando.
	private var NombreCursorAInstanciar:String;
	
	private var HerramientaEnUso:String;// Nombre de la herramienta que estoy usando en este momento
										// para saber a q función tengo q llamar cuando active con el teclado.
	private var circulo: MovieClip;
	private var nuevocirculo: MovieClip;
	private var c:Number=0; //número del círculo que estamos pintando ahora (en un mismo lienzo puede haber varios círculos)
	private var xInicial:Number;
	private var yInicial:Number;
	private var radio: Number;
	private var arrayCirculos:Array = new Array();
	
	private var Cursor2:Object = new Object();
	private var xAnterior:Number;
	private var yAnterior:Number;
/***********************************************************************************************/	
/* Constructor */
/***********************************************************************************************/	
	
	function HerramientasDibujo (){
		super();
		//establecemos el estilo de la línea
		this.lineStyle(1,0x000000,100);
		this.focusEnabled = true;
		this.tabEnabled = true;
	}

/***********************************************************************************************/	
/* Funciones Comunes a todas las herramientas */
/***********************************************************************************************/	

	private function desplazarCursor (): Void {
		//esta función desplaza el cursor por la pantalla dependiendo de la tecla que se haya pulsado
		//y activa el pulsado cuando se pulsa el ENTER
		trace ("on Key Down");
		trace (Cursor);

		tecla = Key.getCode();
		trace ("tecla:"+tecla);
		switch (tecla) {
			case (Key.UP):
				if (dentroDelLienzo(Cursor._x,(Cursor._y - velocidad)))
					Cursor._y = (Cursor._y - velocidad);
				break;
			case (Key.DOWN):
				if (dentroDelLienzo(Cursor._x,(Cursor._y + velocidad)))	
					Cursor._y = (Cursor._y + velocidad);
				break;
			case (Key.LEFT):
				if (dentroDelLienzo((Cursor._x - velocidad),Cursor._y))
					Cursor._x = (Cursor._x - velocidad);
				break;
			case (Key.RIGHT):
				if (dentroDelLienzo((Cursor._x + velocidad),Cursor._y))
					Cursor._x = (Cursor._x + velocidad);
				break;
			case (Key.SPACE):
				if (HerramientaEnUso == "Lápiz")
					activarPintado();
				if (HerramientaEnUso == "Círculo")
					inicioForma();
		}
		updateAfterEvent();
	}

	
	private function moverCursorAPosicionRaton (){
		//mueve el cursor(icono de la herramienta correspondiente) que yo he instanciado
		//a la posición del ratón

		Cursor._x = _root._xmouse;
		Cursor._y = _root._ymouse;
		trace("Cursor._x"+Cursor._x);
		trace("Cursor._y"+Cursor._y);
		trace("_xmouse"+_xmouse);
		trace("_ymouse"+_ymouse);
	}
	
	private function instanciarCursor(){
	// esta función crea el cursor si no ha sido creado previamente.
		if (hayCursor == false) {
		//instanciamos el cursor 
			Cursor = _level0.attachMovie(CursorAInstanciar, NombreCursorAInstanciar,1);
			trace("Cursor_Arg:"+Cursor);
		//ocultamos el ratón y ponemos el cursor como ratón
			//Mouse.hide();
			moverCursorAPosicionRaton;
			hayCursor = true;
		}
	}
	
	private function moverRaton(){
	// esta función controla la posición a la que movemos el ratón. Si se mueve dentro del lienzo y 
	// el cursor no está instanciado, lo instancia y lo mueve a la posición en que esté el ratón.
	// y si se mueve fuera y está ya lo elimina y vuelve a mostrar el puntero de ratón.
		trace("xmouse:"+_xmouse+"+"+"ymouse:"+_ymouse);
		//if (dentroDelLienzo(_root._xmouse,_root._ymouse)){
		if (hitTest (_root._xmouse,_root._ymouse,false)){
			instanciarCursor();
			moverCursorAPosicionRaton();
		}
		else{
			if (Cursor != undefined){
				Cursor.removeMovieClip();
				Mouse.show();
				hayCursor=false;
			}
		}
		updateAfterEvent();
	}
	
	private function dentroDelLienzo (x:Number,y:Number): Boolean{
		//esta función comprueba si las coordenadas recibidas como parámetro están
		//dentro del lienzo.
		var dentro:Boolean;
		return hitTest (_root._xmouse,_root._ymouse,false);
/*		trace("x:"+ x);
		trace("xlienzo:"+ xlienzo);
		trace("acnchoLienzo:"+anchoLienzo);
		trace("y:"+ y);
		trace("ylienzo:"+ylienzo);
		trace("altoLienzo:"+altoLienzo);
		trace("****************************");
*/		if ((x >= xlienzo) && (x <= (anchoLienzo + xlienzo)) &&
			(y >=ylienzo) && (y <= (altoLienzo + ylienzo))){	
				return true
		}
		else{
			return false
		}

//		dentro = this.hitTest(x,y);
//		return dentro;
	}

/***********************************************************************************************/	
/* Herramienta lápiz */
/***********************************************************************************************/	

	
	function herramienta_Lapiz (arg_velocidad:Number, vieneDeTeclado:Boolean){
		
		trace("Herramienta Lápiz");

		// asignamos los parametros recibidos, a los atributos de la clase
		velocidad = arg_velocidad;
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		xlienzo = this._x;
		ylienzo = this._y;
		
		
		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = "Símbolo 3";
		NombreCursorAInstanciar = "CursorLápiz";
		HerramientaEnUso = "Lápiz";
		
		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = xlienzo;
		Cursor._y = ylienzo;
		trace("Cursor.x"+Cursor._x);
		xAnterior = _root._xmouse;
		yAnterior = _root._ymouse;
	//utilizaremos la propia clase como escuchador de ratón.
	//cuando se pulsa el izdo del mouse se llama a marcarPintado
		this.onMouseDown=Delegate.create(this,activarPintado);
		this.onMouseMove=Delegate.create(this,moverRaton);
	//la clase tb funciona como escuchador de teclado
//		this.onRollOver = Delegate.create(this,establecerFoco);
	//al pulsar una tecla llamamos a desplazar cursor
		this.onKeyDown = Delegate.create(this,desplazarCursor);
		Key.addListener(this);
	}

	
//********************RATON***********************************
	//funciones en las que únicamente se maneja el ratón.
	
/* esta función se utiliza solo si no tenemos escuchador general de teclado
	private function establecerFoco(){
		trace("OnRollOver:"+this);
		Selection.setFocus(this);
		this.onRollOver = function(){
			trace("OnRollOver");
		}
	}
*/	
	private function comenzarPintadoLapiz (){
		trace("comenzarPintadoLapiz");
		// situamos el movieClip en las coordenadas iniciales.
		//cuando nos llega un evento de que el ratón se ha movido
		//llamamos a la función pintarLapiz con las nuevas coordenadas del ratón
		this.onMouseMove = Delegate.create(this,prepararCoordenadasPintado);
		this.onMouseDown = Delegate.create(this,desmarcarPintado);
		updateAfterEvent();
	}

	private function prepararCoordenadasPintado(){
		//establece el nuevo punto al que ampliamos la línea que estamos pintando
		//que como hemos llegado a través de un evento de ratón
		//serán las nuevas coordenadas donde hemos desplazado el ratón.
		//llamamos la la función pintarLinea para pintarla
		moverRaton();
		if (dentroDelLienzo(_root._xmouse,_root._ymouse)){
			if (dentroDelLienzo(xAnterior,yAnterior))
			trace ("xAnterior:"+xAnterior);
			trace ("yAnterior:"+yAnterior);
			pintarLinea(_xmouse, _ymouse);
		}
		else{
			//this.moveTo(_xmouse,_ymouse);
		}
		xAnterior = _root._xmouse;
		yAnterior = _root._ymouse;
		updateAfterEvent();
	}	

//********************TECLADO***********************************
	//función de manejo exclusivo de teclado
	private function pintarTeclado (): Void {
		//en esta función se pinta segun los movimientos del teclado
		//o se desactiva el pintado si se pulsa de nuevo ENTER
		
		Cursor2.x = (Cursor._x);
		Cursor2.y = (Cursor._y);
		this.globalToLocal(Cursor2);		
		this.moveTo(Cursor2.x, Cursor2.y);
		tecla = Key.getCode();
		trace ("tecla:"+tecla);
		trace("this.x"+this._x);
		trace("this.y"+this._y);
		trace("Cursor2._x"+Cursor2._x);
		trace("Cursor2._y"+Cursor2._y);
		switch (tecla) {
			case (Key.UP):
				if (dentroDelLienzo(Cursor._x,(Cursor._y - velocidad))){
					Cursor._y = (Cursor._y - velocidad);
					Cursor2.x = (Cursor._x);
					Cursor2.y = (Cursor._y);
					this.globalToLocal(Cursor2);
					pintarLinea(Cursor2.x, Cursor2.y);
				}
				break;
			case (Key.DOWN):
				if (dentroDelLienzo(Cursor._x,(Cursor._y + velocidad))){
					Cursor._y = (Cursor._y + velocidad);
					Cursor2.x = (Cursor._x);
					Cursor2.y = (Cursor._y);
					this.globalToLocal(Cursor2);
					pintarLinea(Cursor2.x, Cursor2.y);				}
				break;
			case (Key.LEFT):
				if (dentroDelLienzo((Cursor._x - velocidad),Cursor._y)){
					Cursor._x = (Cursor._x - velocidad);
					Cursor2.x = (Cursor._x);
					Cursor2.y = (Cursor._y);
					this.globalToLocal(Cursor2);
					pintarLinea(Cursor2.x, Cursor2.y);				}
				break;
			case (Key.RIGHT):
				if (dentroDelLienzo((Cursor._x + velocidad),Cursor._y)){
					Cursor._x = (Cursor._x + velocidad);
					Cursor2.x = (Cursor._x);
					Cursor2.y = (Cursor._y);
					this.globalToLocal(Cursor2);
					pintarLinea(Cursor2.x, Cursor2.y);				}
				break;
			case (Key.SPACE):
				this.onKeyDown = Delegate.create(this,desplazarCursor);
		}
		updateAfterEvent();
	}
	
//********************RATON + TECLADO***********************************
	//funciones que manejan tanto ratón como teclado y que son llamadas por ambos
	
	private function activarPintado (){
		trace("marcarPintadoRaton");
		//Como hemos recibido un evento de ratón, las coordenadas iniciales en las que comenzaremos
		//a pintar serán las coordenadas del ratón, por lo que asignamos a xlapiz e ylapiz los valores
		//de las coordenadas de ratón.
		//Antes de activar el pintado lo q haremos será comprobar si está dentro del lienzo
		//xq si está fuera lo ignoramos.
		//cuando lo levanta cuando se levanta el dedo del ratón, ya estamos listos para pintar
		//se llama a la función PintadoActivo 
		//que se encargará de esperar por los eventos de movimiento (tanto de teclado como de ratón)
		if (dentroDelLienzo(_root._xmouse,_root._ymouse)){
			this.moveTo(_xmouse,_ymouse);
			this.onMouseUp = Delegate.create(this,comenzarPintadoLapiz);
		}
		this.onKeyDown = Delegate.create(this,pintarTeclado);
		updateAfterEvent();
	}
	
	private function pintarLinea (x:Number, y:Number){
		trace("pintarLinea");
		trace("x:"+x+"y"+y);
		trace(this);
		// ponemos en xlapiz e ylapiz las nuevas coordenadas y trazamos una línea hasta ellas
		this.lineTo(x,y);
	}
	
	private function desmarcarPintado(){
		trace("desmarcarPintado");
		//para el pintado cuando se mueve el ratón
		//y prepara para cuando se vuelva a pulsar el ratón comenzar de nuevo el pintado
		if (dentroDelLienzo(Cursor._x, Cursor._y)){
			this.onMouseMove = Delegate.create(this,moverRaton);
			this.onMouseDown= Delegate.create(this,activarPintado);
			this.onMouseUp = Delegate.create(this,null);
		}
		this.onKeyDown = Delegate.create(this,desplazarCursor)
		updateAfterEvent();
	}
	
	
/***********************************************************************************************/	
/*Fin Pintar con Herramienta Lapiz*/
/***********************************************************************************************/	

/***********************************************************************************************/	
/*Formas*/
/***********************************************************************************************/
/*En esta sección se implementará el código de las formas: 
cuadrado, círculo, rectángulo y triángulo*/

	private function inicioForma(){
		if (HerramientaEnUso = "Círculo"){
			//recogemos las coordenadas iniciales (en este caso el centro del círculo)
			Cursor2.x = (Cursor._x);
			Cursor2.y = (Cursor._y);
			this.globalToLocal(Cursor2);		
			xInicial= Cursor2.x;
			yInicial= Cursor2.y;
			this.onMouseMove=Delegate.create(this,prepararCirculo);
			this.onMouseDown=Delegate.create(this,fijarCirculo);
			this.onKeyDown=Delegate.create(this,formasTeclado);
		}
	}
	
	private function formasTeclado (): Void {
		//esta función pinta la forma indicada según la herramienta que se esté utilizando
		//según se va moviendo el cursor.
		tecla = Key.getCode();
		switch (tecla) {
			case (Key.UP):
				if (dentroDelLienzo(Cursor._x,(Cursor._y - velocidad))){
					Cursor._y = (Cursor._y - velocidad);
					if (HerramientaEnUso == "Círculo")
						calcularCirculo();
				}
				break;
			case (Key.DOWN):
				if (dentroDelLienzo(Cursor._x,(Cursor._y + velocidad))){	
					Cursor._y = (Cursor._y + velocidad);
					if (HerramientaEnUso == "Círculo")
						calcularCirculo();
				}
				break;
			case (Key.LEFT):
				if (dentroDelLienzo((Cursor._x - velocidad),Cursor._y)){
					Cursor._x = (Cursor._x - velocidad);
					if (HerramientaEnUso == "Círculo")
						calcularCirculo();
				}
				break;
			case (Key.RIGHT):
				if (dentroDelLienzo((Cursor._x + velocidad),Cursor._y)){
					Cursor._x = (Cursor._x + velocidad);
					if (HerramientaEnUso == "Círculo")
						calcularCirculo();
				}
				break;
			case (Key.SPACE):
				if (HerramientaEnUso == "Círculo")
					fijarCirculo();
		}
	}
/********************************************/
/*Círculo*/
/********************************************/

	function herramienta_Circulo (vieneDeTeclado:Boolean, arg_velocidad:Number){
		
		trace("Herramienta Círculo");

		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		velocidad = arg_velocidad;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = "Símbolo 4";
		NombreCursorAInstanciar = "CursorFormas";
		HerramientaEnUso = "Círculo";

		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = this._x;
		Cursor._y = this._y;

	//utilizaremos la propia clase como escuchador de ratón.
	//cuando se pulsa el izdo del mouse se llama a marcarPintado
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onMouseMove=Delegate.create(this,moverRaton);
	//la clase tb funciona como escuchador de teclado
//		this.onRollOver = Delegate.create(this,establecerFoco);
	//al pulsar una tecla llamamos a desplazar cursor
		this.onKeyDown = Delegate.create(this,desplazarCursor);
		Key.addListener(this);
	}
	
	private function fijarCirculo(){
//		trace(arrayCirculos);
		circulo.duplicateMovieClip("nuevocirculo", this.getNextHighestDepth());
		this.onMouseMove=Delegate.create(this,moverRaton);
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onKeyDown = Delegate.create(this,desplazarCursor);
	}

	private function prepararCirculo(){
		if (dentroDelLienzo(_root._xmouse,_root._ymouse)){
			instanciarCursor();
			moverCursorAPosicionRaton();
			calcularCirculo();
		}
	}
	
	private function calcularCirculo(){

		Cursor2.x = (Cursor._x);
		Cursor2.y = (Cursor._y);
		this.globalToLocal(Cursor2);		
		radio = calculaRadio(xInicial, yInicial, Cursor2.x, Cursor2.y);	
//		if (dentroDelLienzo(xInicial+radio,yInicial+radio) && 
//			dentroDelLienzo(xInicial-radio,yInicial-radio)){
			circulo.removeMovieClip();
			//creamos el movieclip círculo q vamos a pintar
			this.createEmptyMovieClip("circulo", this.getNextHighestDepth());
			circulo._x = xInicial;
			circulo._y = yInicial;
			dibujaCirculo(circulo, radio, 0x99FF00, 100)
//		}
	}

	private function calculaRadio(xinicio:Number, yinicio:Number, xfin:Number, yfin:Number):Number{
		var incx:Number;
		var incy:Number;
		
		incx = xfin - xinicio;
		incy = yfin - yinicio;
		radio = incx*incx + incy*incy;
		radio = Math.sqrt(radio);
		return radio;
	}

	private function dibujaCirculo(circulo:MovieClip, rad:Number, colorRelleno:Number, transparencia:Number):Void {
		//var x:Number = 0;
		//var y:Number = 0;
		Cursor2.x = 0;
		Cursor2.y = 0;
		with (circulo) {
			beginFill(colorRelleno, transparencia); 
			moveTo(Cursor2.x + rad, y);
			curveTo(rad + Cursor2.x, Math.tan(Math.PI / 8) * rad + y, Math.sin(Math.PI / 4) * rad + Cursor2.x, Math.sin(Math.PI / 4) * rad + y);
			curveTo(Math.tan(Math.PI / 8) * rad + Cursor2.x, rad + y, Cursor2.x, rad + y);
			curveTo(-Math.tan(Math.PI / 8) * rad + Cursor2.x, rad+ y, -Math.sin(Math.PI / 4) * rad + Cursor2.x, Math.sin(Math.PI / 4) * rad + y);
			curveTo(-rad + Cursor2.x, Math.tan(Math.PI / 8) * rad + y, -rad + Cursor2.x, y);
			curveTo(-rad + Cursor2.x, -Math.tan(Math.PI / 8) * rad + y, -Math.sin(Math.PI / 4) * rad + Cursor2.x, -Math.sin(Math.PI / 4) * rad + y);
			curveTo(-Math.tan(Math.PI / 8) * rad + Cursor2.x, -rad + y, Cursor2.x, -rad + y);
			curveTo(Math.tan(Math.PI / 8) * rad + Cursor2.x, -rad + y, Math.sin(Math.PI / 4) * rad + Cursor2.x, -Math.sin(Math.PI / 4) * rad + y);
			curveTo(rad + Cursor2.x, -Math.tan(Math.PI / 8) * rad + y, rad + Cursor2, y);
			endFill();
		}
	}


/***********************************************************************************************/	
/*Fin Formas*/
/***********************************************************************************************/	
	
}