﻿/* En este archivo se recoge la implementación de algunas herramientas de dibujo*/
/* Estas herramientas son:
-lápiz
-formas geométricas
-texto
-arrastrar símbolo
-guardar
-imprimir */

import mx.utils.Delegate;

class HerramientasDibujo extends MovieClip{

	private var Cursor:MovieClip;//Cursor que instanciaré e iré moviendo x el lienzo.
								 //globales
	private var velocidad:Number;//velocidad a la que se mueve el cursor por la pantalla(para el teclado)
	private var CursorAInstanciar:String;//esta variable contiene el símbolo de la librería asociado al cursor correspondiente a la herramienta con la que estoy trabajando.
	private var NombreCursorAInstanciar:String;
	private var HerramientaEnUso:String;// Nombre de la herramienta que estoy usando en este momento
										// para saber a q función tengo q llamar cuando active con el teclado.

	private var altoLienzo:Number;//valores iniciales del lienzo.
	private var anchoLienzo:Number;
		
	private var hayCursor:Boolean=false;//cuando instancio el cursor la pongo a true, y cuando lo borro a false
	
	private var Cursor2:Object = new Object();//locales del cursor
	private var xInicialGlobal:Number;
	private var yInicialGlobal:Number;
	
	private var lapiz:MovieClip;
	private var grosorLinea:Number;
	private var colorLinea:Number;
	private var alfaLinea:Number;
	private var pintandoConTeclado:Boolean = false;//me permite saber si estoy pintando una línea con teclado o con ratón
	private var pintando:Boolean = false;//me permite saber si tengo activo el pintado
	private var meSaliPintando:Boolean = false;
	
	private var circulo: MovieClip;
	private var xInicial:Number;
	private var yInicial:Number;
	private var radio: Number;
	private var rectangulo: MovieClip;
	private var triangulo:MovieClip;
	private var cuadrado:MovieClip;
	
	private var sello:MovieClip;
//	private var nuevosello:MovieClip;
	private var pulsaSello:Boolean; 
	
	private var Bocadillo:MovieClip;
	private var textoBocadillo:MovieClip;
	private	var anchoBocadillo:Number;
	private	var altoBocadillo:Number;	
	private var n:Number;
	private var cursorActivo:Boolean = true;
/***********************************************************************************************/	
/* Constructor */
/***********************************************************************************************/	
	
	function HerramientasDibujo (){
		super();
		this.focusEnabled = true;
		this.tabEnabled = true;
	}

/***********************************************************************************************/	
/* Funciones Comunes a todas las herramientas */
/***********************************************************************************************/	
	function recogerCoordenadasRaton (){
		var xRaton:Number;
		var yRaton:Number;
		
		xRaton = _root._xmouse;
		yRaton = _root._ymouse;
		pintandoConTeclado=false;
		moverCursor(xRaton,yRaton);
		if (pintando == true)
			switch (HerramientaEnUso){
				case("Lápiz"):
					pintar();
					break;
				case("Círculo"):
					calcularCirculo();
					break;
				case("Rectángulo"):
					calcularRectangulo();
					break;
				case("Triángulo"):
					calcularTriangulo();
					break;
				case("Cuadrado"):
					calcularCuadrado();
					break;
			}
	}
	
	private function recogerCoordenadasTeclado(){
		//Esta función recoge las coordenadas a las que desplazaremos el cursor tras pulsar una tecla. 
		//y activa el pintado cuando se pulsa el ENTER
		var tecla:Number;
		
		tecla = Key.getCode();
		switch (tecla) {
			case (Key.UP):
				moverCursor(Cursor._x,Cursor._y - velocidad);
				break;
			case (Key.DOWN):
				moverCursor(Cursor._x,Cursor._y + velocidad);
				break;
			case (Key.LEFT):
				moverCursor(Cursor._x - velocidad,Cursor._y);
				break;
			case (Key.RIGHT):
				moverCursor(Cursor._x + velocidad,Cursor._y);
				break;
			case (Key.SPACE):
			//Activamos/desactivamos una u otra herramienta.
				switch (NombreCursorAInstanciar){
					case("CursorLápiz"):
						if (pintando == false)
							activarPintado();
						else
							desactivarPintado();
						break;
					case("CursorFormas"):
						if (pintando == false)
							inicioForma();
						else
							fijarForma();
						break;
					case("CursorSello"):
						if (pintando == false){
							if (pulsaSello == true)
								fijarSello();
							else
								fijarBocadillo();
						}
				}
		}
		pintandoConTeclado = true;
		//si estoy pintando, ad+ de lo anterior y dependiendo de la herramienta dibujo
		//pintamos líneas, círculos,...
		if (pintando == true)
			switch (HerramientaEnUso){
				case("Lápiz"):
					pintar();
					break;
				case("Círculo"):
					calcularCirculo();
					break;
				case("Rectángulo"):
					calcularRectangulo();
					break;
				case("Triángulo"):
					calcularTriangulo();
					break;					
				case("Cuadrado"):
					calcularCuadrado();
					break;					
			}
		updateAfterEvent();
	}
	
	function moverCursor(x:Number,y:Number){
	//Esta función controla la posición a la que vamos a mover el ratón.
	//Si la posición indicada como parámetro está dentro del lienzo llama a instanciar lienzo 
	//(que lo instanciará si no está instanciado y oculta el puntero de ratón) y se mueve a dicha posición.
	//Si está fuera del lienzo y el cursor estaba instanciado lo elimina y vuelve a mostrar el puntero del ratón.
		if (dentroDelLienzo(x,y)){
			instanciarCursor();
			Cursor._x = x;
			Cursor._y = y;
		}
		else{
			if (pintandoConTeclado == false){
				if (Cursor != undefined){
					Cursor.removeMovieClip();
					Mouse.show();
					hayCursor=false;
					if (pintando==true)
						meSaliPintando = true;
				}
			}
		}
		updateAfterEvent();
	}
	
	private function instanciarCursor(){
	// esta función crea el cursor si no ha sido creado previamente.
		if (hayCursor == false) {
		//instanciamos el cursor 
			if (cursorActivo == true){
				Cursor = _level0.attachMovie(CursorAInstanciar, NombreCursorAInstanciar,this.getNextHighestDepth());
			//ocultamos el ratón y ponemos el cursor como ratón
				Mouse.hide();
				hayCursor = true;
			}
		}
	}

	private function dentroDelLienzo (x:Number,y:Number): Boolean{
		//esta función comprueba si las coordenadas recibidas como parámetro están
		//dentro del lienzo.
		var dentro:Boolean;
		dentro = this.hitTest(x,y);
		return dentro;
	}
	
	
/***********************************************************************************************/	
/* Herramienta Lápiz */
/***********************************************************************************************/	

	function herramienta_Lapiz (arg_velocidad:Number, vieneDeTeclado:Boolean, grosor:Number,
								color:Number, alfa:Number, cursorBiblioteca:String){
		
		// asignamos los parametros recibidos, a los atributos de la clase
		velocidad = arg_velocidad;
		grosorLinea = grosor;
		colorLinea = color;
		alfaLinea = alfa;
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = cursorBiblioteca;
		NombreCursorAInstanciar = "CursorLápiz";
		HerramientaEnUso = "Lápiz";
		//me aseguro de que al moverse al principio no pinte nada (por si viene con el pintado activo de otra herramienta)
		pintando = false;
		cursorActivo = true;
		if (vieneDeTeclado) {
			instanciarCursor();
			Cursor._x = this._x;
			Cursor._y = this._y;
		}
	//utilizaremos la propia clase como escuchador de ratón.
		this.onMouseDown=Delegate.create(this,activarPintado);
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
	//la clase tb funciona como escuchador de teclado
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		Key.addListener(this);
	}
	

	private function activarPintado(){
		Cursor2.x = (Cursor._x);
		Cursor2.y = (Cursor._y);
		this.globalToLocal(Cursor2);		
		//this.moveTo(Cursor2.x, Cursor2.y);
		pintando = true;
		lapiz.removeMovieClip();
		this.createEmptyMovieClip("lapiz",this.getNextHighestDepth());
		lapiz.moveTo(Cursor2.x, Cursor2.y);		
		this.onMouseDown=Delegate.create(this,desactivarPintado);		
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
	}
	
	private function pintar(){
		trace("pintando");
		if (pintando == true){
			if (hayCursor == true){
				Cursor2.x = (Cursor._x);
				Cursor2.y = (Cursor._y);
				this.globalToLocal(Cursor2);
				if (meSaliPintando == true){
					meSaliPintando = false;
					lapiz.moveTo(Cursor2.x, Cursor2.y);
					//this.moveTo(Cursor2.x, Cursor2.y);					
				}
				else
					pintarLinea(Cursor2.x, Cursor2.y);
			}
		}		
	}
	
	private function pintarLinea (x:Number, y:Number){
	//esta función pinta una línea desde el último punto hasta el punto actual
		lapiz.lineStyle(grosorLinea, colorLinea, alfaLinea);
		lapiz.lineTo(x,y);
		//this.lineTo(x,y);
	}
	
	private function desactivarPintado(){
		//cuando pulsamos otra vez el botón izquierdo del mouse o el botón de selección del teclado
		//se desactiva el pintado y se reestablece el estado inicial
		//el cursor se puede mover sin pintar y se prepara el pintador para volver a pintar mas adelante.
		pintando = false;
		lapiz.duplicateMovieClip("nuevolapiz", this.getNextHighestDepth());
		if (dentroDelLienzo(Cursor._x, Cursor._y)){
			this.onMouseMove = Delegate.create(this,recogerCoordenadasRaton);
			this.onMouseDown= Delegate.create(this,activarPintado);
			this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado)
		}
		updateAfterEvent();

	}
/***********************************************************************************************/	
/*Fin Pintar con Herramienta Lapiz*/
/***********************************************************************************************/	
/***********************************************************************************************/	
/*Formas*/
/***********************************************************************************************/
/*En esta sección se implementará el código de las formas: 
cuadrado, círculo, rectángulo y triángulo*/

	private function inicioForma(){
		trace(HerramientaEnUso);
		if (NombreCursorAInstanciar == "CursorFormas"){
			//recogemos las coordenadas iniciales (en este caso el centro del círculo)
			Cursor2.x = (Cursor._x);
			Cursor2.y = (Cursor._y);
			xInicialGlobal = Cursor._x;
			yInicialGlobal = Cursor._y;
			this.globalToLocal(Cursor2);		
			xInicial= Cursor2.x;
			yInicial= Cursor2.y;
			pintando = true;
			this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
			this.onMouseDown=Delegate.create(this,fijarForma);
			this.onKeyDown=Delegate.create(this,recogerCoordenadasTeclado);
		}
	}
	
	private function fijarForma(){
		//esta función fija en el lienzo la forma que estuvieramos pintando
		//y lo deja todo preparado para pintar otra  nueva forma
		pintando = false;
		switch (HerramientaEnUso){
			case("Círculo"):
				circulo.duplicateMovieClip("nuevocirculo", this.getNextHighestDepth());
				break;
			case("Rectángulo"):
				rectangulo.duplicateMovieClip("nuevorectangulo", this.getNextHighestDepth());
				break;
			case("Triángulo"):
				triangulo.duplicateMovieClip("nuevotriangulo", this.getNextHighestDepth());
				break;
			case("Cuadrado"):
				cuadrado.duplicateMovieClip("nuevocuadrado", this.getNextHighestDepth());
				break;
		}		
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
	}


/********************************************/
/*Círculo*/
/********************************************/

	function herramienta_Circulo (vieneDeTeclado:Boolean, arg_velocidad:Number){
		
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		velocidad = arg_velocidad;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = "Símbolo 4";
		NombreCursorAInstanciar = "CursorFormas";
		HerramientaEnUso = "Círculo";
		//me aseguro de que al moverse al principio no pinte nada (por si viene con el pintado activo de otra herramienta)
		pintando = false;
		cursorActivo = true;

		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = this._x;
		Cursor._y = this._y;

	//utilizaremos la propia clase como escuchador de ratón.
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
	//la clase tb funciona como escuchador de teclado
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		Key.addListener(this);
	}

	private function calcularCirculo(){
		trace("calcularCirculo");
		var radio2:Number;
		
		Cursor2.x = Cursor._x;
		Cursor2.y = Cursor._y;
		this.globalToLocal(Cursor2);

		radio = calculaRadio(xInicialGlobal, yInicialGlobal, Cursor._x, Cursor._y);	
		radio2 = calculaRadio(xInicial, yInicial, Cursor2.x, Cursor2.y);	
		if (dentroDelLienzo(xInicialGlobal+radio,yInicialGlobal+radio) && 
			dentroDelLienzo(xInicialGlobal-radio,yInicialGlobal-radio)){
			circulo.removeMovieClip();
			//creamos el movieclip círculo q vamos a pintar
			this.createEmptyMovieClip("circulo", this.getNextHighestDepth());
			//circulo = this.attachMovie("Símbolo5", "circulo",this.getNextHighestDepth());
			dibujaCirculo(circulo, radio2, 0x99FF00, 100)
		}
	}

	private function calculaRadio(xinicio:Number, yinicio:Number, xfin:Number, yfin:Number):Number{
		var incx:Number;
		var incy:Number;
		incx = xfin - xinicio;
		incy = yfin - yinicio;
		radio = incx*incx + incy*incy;
		radio = Math.sqrt(radio);
		return radio;
	}

	private function dibujaCirculo(circulo:MovieClip, rad:Number, colorRelleno:Number, transparencia:Number):Void {
		trace("dibujaCirculo");
		var x:Number = xInicial;
		var y:Number = yInicial;

		with (circulo){
			beginFill(colorRelleno, transparencia); 
			moveTo(x + rad, y);
			curveTo(rad + x, Math.tan(Math.PI / 8) * rad + y, Math.sin(Math.PI / 4) * rad + x, Math.sin(Math.PI / 4) * rad + y);
			curveTo(Math.tan(Math.PI / 8) * rad + x, rad + y, x, rad + y);
			curveTo(-Math.tan(Math.PI / 8) * rad + x, rad+ y, -Math.sin(Math.PI / 4) * rad + x, Math.sin(Math.PI / 4) * rad + y);
			curveTo(-rad + x, Math.tan(Math.PI / 8) * rad + y, -rad + x, y);
			curveTo(-rad + x, -Math.tan(Math.PI / 8) * rad + y, -Math.sin(Math.PI / 4) * rad + x, -Math.sin(Math.PI / 4) * rad + y);
			curveTo(-Math.tan(Math.PI / 8) * rad + x, -rad + y, x, -rad + y);
			curveTo(Math.tan(Math.PI / 8) * rad + x, -rad + y, Math.sin(Math.PI / 4) * rad + x, -Math.sin(Math.PI / 4) * rad + y);
			curveTo(rad + x, -Math.tan(Math.PI / 8) * rad + y, rad + x, y);
			endFill();
		}
	}

/********************************************/
/*Rectángulo*/
/********************************************/

	function herramienta_Rectangulo (vieneDeTeclado:Boolean, arg_velocidad:Number){
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		velocidad = arg_velocidad;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = "Símbolo 4";
		NombreCursorAInstanciar = "CursorFormas";
		HerramientaEnUso = "Rectángulo";

		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = this._x;
		Cursor._y = this._y;
		//me aseguro de que al moverse al principio no pinte nada (por si viene con el pintado activo de otra herramienta)
		pintando = false;
		cursorActivo = true;

	//utilizaremos la propia clase como escuchador de ratón.
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
	//la clase tb funciona como escuchador de teclado
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		Key.addListener(this);
	}
	
	private function calcularRectangulo(){

		if (dentroDelLienzo(Cursor._x,Cursor._y)){
			rectangulo.removeMovieClip();
			//creamos el movieclip rectangulo q vamos a pintar
			Cursor2.x = Cursor._x;
			Cursor2.y = Cursor._y;
			this.globalToLocal(Cursor2);
			this.createEmptyMovieClip("rectangulo", this.getNextHighestDepth());
			trace("esta dentro")
			rectangulo._x = xInicial;
			rectangulo._y = yInicial;
			dibujaRectangulo(rectangulo, Cursor2.x - xInicial, Cursor2.y - yInicial, 0x9900FF, 100);
		}
	}
	
	function dibujaRectangulo(rectangulo:MovieClip, ancho:Number, alto:Number, colorRelleno:Number,
							  transparencia:Number):Void {
		with (rectangulo) {
			beginFill(colorRelleno, transparencia);
			moveTo(0, 0);
			lineTo(ancho, 0);
			lineTo(ancho, alto);
			lineTo(0, alto);
			lineTo(0, 0);
			endFill();
		}
	}
/********************************************/
/*Triángulo*/
/********************************************/

	function herramienta_Triangulo (vieneDeTeclado:Boolean, arg_velocidad:Number){
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		velocidad = arg_velocidad;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = "Símbolo 4";
		NombreCursorAInstanciar = "CursorFormas";
		HerramientaEnUso = "Triángulo";
		cursorActivo = true;

		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = this._x;
		Cursor._y = this._y;
		//me aseguro de que al moverse al principio no pinte nada (por si viene con el pintado activo de otra herramienta)
		pintando = false;

	//utilizaremos la propia clase como escuchador de ratón.
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
	//la clase tb funciona como escuchador de teclado
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		Key.addListener(this);
	}
	
	private function calcularTriangulo(){
		if (dentroDelLienzo(Cursor._x,Cursor._y)){
			triangulo.removeMovieClip();
			//creamos el movieclip rectangulo q vamos a pintar
			Cursor2.x = Cursor._x;
			Cursor2.y = Cursor._y;
			this.globalToLocal(Cursor2);
			this.createEmptyMovieClip("triangulo", this.getNextHighestDepth());
			dibujaTriangulo(triangulo, xInicial, yInicial, Cursor2.x, Cursor2.y, 0x00CCFF, 100);
		}
	}
	
	function dibujaTriangulo(triangulo:MovieClip, xI:Number, yI:Number, xF:Number, yF:Number,
							  colorRelleno:Number, transparencia:Number):Void {
		var puntoMedio:Number;
		
		puntoMedio = xI + (xF - xI)/2;
		with (triangulo) {
			beginFill(colorRelleno, transparencia);
			moveTo(xI,yF);
			lineTo(puntoMedio,yI);
			lineTo(xF,yF);
			lineTo(xI,yF)
			endFill();
		}
	}
	
/********************************************/
/*Cuadrado*/
/********************************************/

	function herramienta_Cuadrado (vieneDeTeclado:Boolean, arg_velocidad:Number){
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		velocidad = arg_velocidad;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = "Símbolo 4";
		NombreCursorAInstanciar = "CursorFormas";
		HerramientaEnUso = "Cuadrado";
		cursorActivo = true;

		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = this._x;
		Cursor._y = this._y;
		//me aseguro de que al moverse al principio no pinte nada (por si viene con el pintado activo de otra herramienta)
		pintando = false;

	//utilizaremos la propia clase como escuchador de ratón.
		this.onMouseDown=Delegate.create(this,inicioForma);
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
	//la clase tb funciona como escuchador de teclado
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		Key.addListener(this);
	}
	
	private function calcularCuadrado(){
		var ancho:Number = Cursor2.x - xInicial;
		var alto:Number = Cursor2.y - yInicial;
		var anchoGlobal:Number = Cursor._x - xInicialGlobal;
		var altoGlobal:Number = Cursor._y - yInicialGlobal;
		var mayor:Number;
		
/*		if (ancho>alto)
			mayor = ancho;
		else
			mayor = alto;
			*/
		if (dentroDelLienzo(Cursor._x,Cursor._y)){
			cuadrado.removeMovieClip();
			//creamos el movieclip rectangulo q vamos a pintar
			Cursor2.x = Cursor._x;
			Cursor2.y = Cursor._y;
			this.globalToLocal(Cursor2);
			this.createEmptyMovieClip("cuadrado", this.getNextHighestDepth());
			cuadrado._x = xInicial;
			cuadrado._y = yInicial;
			if (ancho < alto)
				dibujaRectangulo(cuadrado, ancho, ancho, 0xFF0000, 100);
			else
				dibujaRectangulo(cuadrado, alto, alto, 0xFF0000, 100);
		}
	}

/***********************************************************************************************/	
/*Fin Formas*/
/***********************************************************************************************/
/***********************************************************************************************/	
/*Sellos*/
/***********************************************************************************************/	
	function herramienta_Sello (vieneDeTeclado:Boolean, arg_velocidad:Number, Sello:String, 
								arg_pulsaSello:Boolean, arg_n:Number){
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		velocidad = arg_velocidad;
		n = arg_n;
		pulsaSello = arg_pulsaSello;

		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		CursorAInstanciar = Sello;
		NombreCursorAInstanciar = "CursorSello";
		HerramientaEnUso = "Sello";
		pintando = false;
		cursorActivo = true;
	

		if (vieneDeTeclado) {
			instanciarCursor();
		}
		Cursor._x = this._x;
		Cursor._y = this._y;
		
	//utilizaremos la propia clase como escuchador de ratón.
		if (pulsaSello == true)
			this.onMouseDown=Delegate.create(this,fijarSello);
		else
			this.onMouseDown=Delegate.create(this,fijarBocadillo);
		this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
	//la clase tb funciona como escuchador de teclado
		this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		Key.addListener(this);
	}
	
	private function fijarSello(){
		//Soltamos el sello

		//y devolvemos el cursor a su forma de flecha original.
		if (dentroDelLienzo(Cursor._x + Cursor._width, Cursor._y + Cursor._height)){
			Cursor2.x = Cursor._x;
			Cursor2.y = Cursor._y;
			this.globalToLocal(Cursor2);
			sello = this.attachMovie(CursorAInstanciar,"sellofijo",this.getNextHighestDepth());
			this.sello._x = Cursor2.x;
			this.sello._y = Cursor2.y;
			Cursor.removeMovieClip();
			Mouse.show();
			this.onMouseDown=function(){}
			this.onMouseMove=function(){}
			this.onKeyDown=function(){}
		}
	}
/***********************************************************************************************/	
/*Fin Sellos*/
/***********************************************************************************************/	
/***********************************************************************************************/	
/*Texto*/
/***********************************************************************************************/	
	private function fijarBocadillo(){
		if (dentroDelLienzo(Cursor._x + Cursor._width, Cursor._y + Cursor._height)){
			Cursor2.x = Cursor._x;
			Cursor2.y = Cursor._y;
			this.globalToLocal(Cursor2);
			
			Bocadillo = this.attachMovie(CursorAInstanciar, "Bocadillo",this.getNextHighestDepth());
			
			Bocadillo.onRelease = function (){
				trace("sobre bocadillo");
			}
			this.createTextField("textoBocadillo", 1, 10, 10, 300, 20);
			textoBocadillo.border = true;
			textoBocadillo.type = "input";
			textoBocadillo.multiline = true;
			//textoBocadillo.fontSize =30;
			textoBocadillo.maxChars = 50;
			textoBocadillo._visible = true;
			//Bocadillo.createObject("TextArea","textoBocadillo",Bocadillo.getNextHighestDepth());

			Bocadillo._x = Cursor2.x;
			Bocadillo._y = Cursor2.y;

			Cursor.removeMovieClip();
			Mouse.show();
			cursorActivo = false;
			this.onMouseDown=function(){};
			escribir();
		}
	}
	
	private function escribir(){
		textoBocadillo._x = Bocadillo._x + 27;
		textoBocadillo._y = Bocadillo._y + 27;
		anchoBocadillo = Bocadillo._width;
		altoBocadillo = Bocadillo._height;		
		Bocadillo._height = 200;
		Bocadillo._width = 200;
		textoBocadillo._height = 100;
		textoBocadillo._width = 140;
		this.Bocadillo.onMouseDown = function (){};
	}
	
	function restablecer(){
		Bocadillo.textoBocadillo.text = textoBocadillo.text;
		textoBocadillo.removeTextField();
		Bocadillo._height = altoBocadillo;
		Bocadillo._width = anchoBocadillo;
		//Bocadillo.textoBocadillo.type = "dynamic";
		//trace(Bocadillo.textoBocadillo.type);
	}
/***********************************************************************************************/	
/*Fin Texto*/
/***********************************************************************************************/	
}