﻿/* En este archivo se recoge la implementación de algunas herramientas de dibujo*/
/* Estas herramientas son:
-lápiz
-texto
-arrastrar símbolo
-guardar
-imprimir */

import mx.utils.Delegate;

class HerramientasDibujo {

	//movieclip sobre el que vamos a pintar
	private var lienzo:MovieClip;
	private var Cursor:MovieClip;
	private var velocidad:Number;//velocidad a la que se mueve el cursor por la pantalla(para el teclado)
	//coordenadas a las que se va moviendo el cursor y el ratón al 
	//pintar con la herramienta lápiz
	private var xlapiz:Number;
	private var ylapiz:Number;
	
	private var tecla:Number;


	private function desplazarCursor (): Void {
		//esta función desplaza el cursor por la pantalla dependiendo de la tecla que se haya pulsado
		//y activa el pulsado cuando se pulsa el ENTER
		trace ("on Key Down");
		trace (Cursor);
		trace (lienzo);

		tecla = Key.getCode();
		trace ("tecla:"+tecla);
		switch (tecla) {
			case (Key.UP):
				Cursor._y = (Cursor._y - velocidad);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.DOWN):
				Cursor._y = (Cursor._y + velocidad);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.LEFT):
				Cursor._x = (Cursor._x - velocidad);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.RIGHT):
				Cursor._x = (Cursor._x + velocidad);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.SPACE):
				marcarPintado();
		}
	}

	
/***********************************************************************************************/	
/* Herramienta lápiz */
/***********************************************************************************************/	

	//function herramienta_Lapiz (arg_lienzo:MovieClip, arg_Cursor:MovieClip, arg_velocidad:Number){
function herramienta_Lapiz (padre: MovieClip, arg_lienzo:String, arg_Cursor:MovieClip, arg_velocidad:Number){
		trace("Herramienta Lápiz");
	//Como parámetro recibimos el movieclip sobre el que vamos a pintar y el cursor para el pintado con teclado.
	// asignamos los parametros recibidos, a los atributos de la clase
		Cursor = arg_Cursor;
		lienzo =padre.attachMovie(arg_lienzo, arg_lienzo+"1", padre.getNextHighestDepth());;
		velocidad = arg_velocidad;
		trace("Cursor_Arg:"+this.lienzo);
		trace("Cursor Asignado:"+this.Cursor);
	//utilizaremos el propio lienzo como escuchador de ratón.
	//establecemos el estilo de la línea
		this.lienzo.lineStyle(1,0x000000,100);
	//cuando se pulsa el izdo del mouse se llama a marcarPintado
		this.lienzo.onMouseDown=Delegate.create(this,marcarPintado);	
	//preparamos el propio lienzo como escuchador de teclado
		this.lienzo.focusEnabled = true;
		this.lienzo.tabEnabled = true;
		this.lienzo.focusRect = true;
		this.lienzo.tabIndex = 1;
		this.lienzo.onRollOver = Delegate.create(this,establecerFoco);
			//al pulsar una tecla llamamos a desplazar cursor
		this.lienzo.onKeyDown = Delegate.create(this,desplazarCursor);
		//Key.addListener(lienzo);
		this.lienzo.onSetFocus = function (){
			trace("Foco establecido en lienzo");
		}
		this.lienzo.onKillFocus = function(){
			trace("perdiendo el foco");};
	}
	
	private function establecerFoco(){
		trace("OnRollOver:"+lienzo);
		Selection.setFocus(lienzo);
		lienzo.onRollOver = function(){
		trace("OnRollOver")}
	}
	
	private function marcarPintado (){
		trace("marcarPintadoRaton");
		//Como hemos recibido un evento de ratón, las coordenadas iniciales en las que comenzaremos
		//a pintar serán las coordenadas del ratón, por lo que asignamos a xlapiz e ylapiz los valores
		//de las coordenadas de ratón.
		xlapiz = _xmouse;
		ylapiz = _ymouse;
		//cuando lo levanta cuando se levanta el dedo del ratón, ya estamos listos para pintar
		//se llama a la función PintadoActivo 
		//que se encargará de esperar por los eventos de movimiento (tanto de teclado como de ratón)
		this.lienzo.onMouseUp = Delegate.create(this,comenzarPintadoLapiz);
		this.lienzo.onKeyDown = Delegate.create(this,pintarTeclado);
	}
	
	private function pintarTeclado (): Void {
		//en esta función se pinta segun los movimientos del teclado
		//o se desactiva el pintado si se pulsa de nuevo ENTER
		
		lienzo.moveTo(Cursor._x, Cursor._y);

		tecla = Key.getCode();
		trace ("tecla:"+tecla);
		switch (tecla) {
			case (Key.UP):
				Cursor._y = (Cursor._y - velocidad);
				lienzo.lineTo(Cursor._x, Cursor._y);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.DOWN):
				Cursor._y = (Cursor._y + velocidad);
				lienzo.lineTo(Cursor._x, Cursor._y);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.LEFT):
				Cursor._x = (Cursor._x - velocidad);
				lienzo.lineTo(Cursor._x, Cursor._y);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.RIGHT):
				Cursor._x = (Cursor._x + velocidad);
				lienzo.lineTo(Cursor._x, Cursor._y);
				trace ("Cursor.y:"+_root.Cursor._y+"Cursor.x"+_root.Cursor._x);
				break;
			case (Key.SPACE):
				lienzo.onKeyDown = Delegate.create(this,desplazarCursor);
		}
	}
	private function comenzarPintadoLapiz (){
		trace("comenzarPintadoLapiz");
		// situamos el movieClip en las coordenadas iniciales.
		lienzo.moveTo(xlapiz, ylapiz);
		//cuando nos llega un evento de que el ratón se ha movido
		//llamamos a la función pintarLapiz con las nuesvas coordenadas del ratón
		lienzo.onMouseMove = Delegate.create(this,establecerCoordenadasLineaRaton);
		lienzo.onMouseDown = Delegate.create(this,desmarcarPintado);
	}

	private function establecerCoordenadasLineaRaton(){
		//establece el nuevo punto al que ampliamos la línea que estamos pintando
		//que como hemos llegado a través de un evento de ratón
		//serán las nuevas coordenadas donde hemos desplazado el ratón.
		xlapiz = _xmouse;
		ylapiz = _ymouse;
		//llamamos la la función pintarLinea para pintarla
		pintarLinea(xlapiz, ylapiz);
	}	

	private function pintarLinea (x:Number, y:Number){
		trace("pintarLinea");
		// ponemos en xlapiz e ylapiz las nuevas coordenadas y trazamos un línea hasta ellas
		lienzo.lineTo(x,y);
	}
	
	private function desmarcarPintado(){
		trace("desmarcarPintado");
		//para el pintado cuando se mueve el ratón
		//y prepara para cuando se vuelva a pulsar el ratón comenzar de nuevo el pintado
		lienzo.onMouseMove = Delegate.create(this,null);
		lienzo.onMouseDown= Delegate.create(this,marcarPintado);
		lienzo.onMouseUp = Delegate.create(this,null);
	}
	
	
/***********************************************************************************************/	
/*Fin Pintar con Herramienta Lapiz*/
/***********************************************************************************************/	
	
}