﻿import mx.utils.Delegate;
import Herramienta;

class Lienzo extends MovieClip{
	
	public var herramientaUtilizada:Herramienta; //herramienta con la que voy a trabajar
	private var velocidad:Number;//pixeles que desplazo el lienzo por cada movimiento de teclado
	private var vieneDeTeclado:Boolean; //si hemos llegad por teclado o por ratón
	private var grosor:Number; //si la herramienta pinta con algun grosor que queramos controlar
								// para que no se nos salga del lienzo (lápiz),
								//lo recibiremos como parametro si no recibimos nada será 0
	
	private var Cursor:MovieClip;
	private var CursorAInstanciar:String;//esta variable contiene el símbolo de la librería asociado al cursor correspondiente a la herramienta con la que estoy trabajando.
	private var NombreCursorAInstanciar:String;
	
	private var altoLienzo:Number;//valores iniciales del lienzo.
	private var anchoLienzo:Number;
		
	private var hayCursor:Boolean=false;//cuando instancio el cursor la pongo a true, y cuando lo borro a false
	private var cursorActivo:Boolean = true;
	private var pintando:Boolean = false;
	private var pintandoConTeclado:Boolean = false;//me permite saber si estoy pintando una línea con teclado o con ratón
	private var meSaliPintando:Boolean = false;
	private var desactivar:Boolean = false;
	

	
/***********************************************************************************************/	
/* Constructor */
/***********************************************************************************************/	
	
	function Lienzo (){
		super();
		//establecemos el estilo de la línea
		this.focusEnabled = true;
		this.tabEnabled = true;
	}	
	
	function desactivarLienzo (){
		trace("desactivar Lienzo");
		Cursor.removeMovieClip();
		this.onMouseDown=function(){};
		this.onMouseMove=function(){};
		this.onKeyDown=function(){};
		Key.removeListener(this);
	}
	
	function desactivarLienzoTecladoActivo (){
		var tecla:Number;

		Mouse.show();
		//Cursor._visible = false;
		Cursor.removeMovieClip();
		this.onMouseDown=function(){};
		this.onMouseMove=function(){};
		this.onKeyDown=function(){
			tecla = Key.getCode();
			if (tecla == Key.ENTER){
				trace("BEL: Pulsado enter");
				herramientaUtilizada.finalizarPintado();
				this.onKeyDown = function(){};
				_root.establecerLienzo(this);
			}
		}
		Key.addListener(this);
	}
	
	function HerramientaEnUso(herram: Herramienta, vel:Number, teclado:Boolean, gro:Number){
		var propiedadesCursor:Array;
		
		// asignamos la herramienta recibida como la herramienta en uso y la velocidad del cursor
		herramientaUtilizada = herram;
		velocidad = vel;
		vieneDeTeclado = teclado;

		if (gro != undefined)
			grosor = gro;
		else
			grosor = 0;
		trace ("GROSOR" + grosor);
			
		// recogemos las dimensiones del lienzo
		anchoLienzo = this._width;
		altoLienzo = this._height;
		
		//asignamos a las vbles q utilizaremos para instanciar el cursor el valor de lápiz
		propiedadesCursor = herramientaUtilizada.dameInformacionCursor();
		CursorAInstanciar = propiedadesCursor[0];
		NombreCursorAInstanciar = propiedadesCursor[1];
		
		if (hayCursor){
			Cursor.removeMovieClip(); 
		}
		hayCursor = false;
		//me aseguro de que al moverse al principio no pinte nada (por si viene con el pintado activo de otra herramienta)
		pintando = false;
		cursorActivo = true;
		if (vieneDeTeclado) {
			trace ("BEL: pintando herramienta en uso" + pintando);
			instanciarCursor();
			Cursor._x = this._x + 10;
			Cursor._y = this._y + 10;
			//utilizaremos la propia clase como escuchador de ratón.
			this.onMouseDown=function(){};
			this.onMouseMove=function(){};
			//la clase tb funciona como escuchador de teclado
			this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
		}
		else{
		//utilizaremos la propia clase como escuchador de ratón.
			this.onMouseDown=Delegate.create(this,activarHerramienta);
			this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
			this.onKeyDown = function(){};
		}
		Key.addListener(this);
	}
	
	private function dentroDelLienzo (xrec:Number,yrec:Number): Boolean{
		//esta función comprueba si las coordenadas recibidas como parámetro están
		//dentro del lienzo.
		var dentro:Boolean;
/*		dentro = this.hitTest(xrec,yrec);
*/		trace ("ancho y alto: " + this._width + " , " + this._height);
		
		if ((this._x + anchoLienzo - grosor > xrec) and (xrec > grosor + this._x) and
			(this._y + altoLienzo - grosor > yrec) and (yrec> grosor + this._y))
			dentro = true;
		else
			dentro = false;
		trace ("dentroDelLienzo" + dentro);
		return dentro;
	}
	
	private function instanciarCursor(){
	// esta función crea el cursor si no ha sido creado previamente.
		if (hayCursor == false) {
		//instanciamos el cursor 
			if (cursorActivo == true){
				Cursor = this._parent.attachMovie(CursorAInstanciar, NombreCursorAInstanciar,this.getNextHighestDepth());
			//ocultamos el ratón y ponemos el cursor como ratón
				Mouse.hide();
				hayCursor = true;
			}
		}
	}

	function moverCursor(x:Number,y:Number){
	//Esta función controla la posición a la que vamos a mover el ratón.
	//Si la posición indicada como parámetro está dentro del lienzo llama a instanciar lienzo 
	//(que lo instanciará si no está instanciado y oculta el puntero de ratón) y se mueve a dicha posición.
	//Si está fuera del lienzo y el cursor estaba instanciado lo elimina y vuelve a mostrar el puntero del ratón.
		if (dentroDelLienzo(x,y)){
			instanciarCursor();
			Cursor._x = x;
			Cursor._y = y;
		}
		else{
			if (pintandoConTeclado == false){
				if (Cursor != undefined){
					Cursor.removeMovieClip();
					Mouse.show();
					hayCursor=false;
					if (pintando==true)
						meSaliPintando = true;
				}
			}
		}
		updateAfterEvent();
	}

	function recogerCoordenadasRaton (){
		var xRaton:Number;
		var yRaton:Number;
		
		xRaton = _root._xmouse;
		yRaton = _root._ymouse;
		pintandoConTeclado=false;
		moverCursor(xRaton,yRaton);
		if (pintando == true)
			pinta();
	}
	
	private function recogerCoordenadasTeclado(){
		//Esta función recoge las coordenadas a las que desplazaremos el cursor tras pulsar una tecla. 
		//y activa el pintado cuando se pulsa el ENTER
		var tecla:Number;
		pintandoConTeclado = true;
		tecla = Key.getCode();
		switch (tecla) {
			case (Key.UP):
				moverCursor(Cursor._x,Cursor._y - velocidad);
				break;
			case (Key.DOWN):
				moverCursor(Cursor._x,Cursor._y + velocidad);
				break;
			case (Key.LEFT):
				moverCursor(Cursor._x - velocidad,Cursor._y);
				break;
			case (Key.RIGHT):
				moverCursor(Cursor._x + velocidad,Cursor._y);
				break;
			case (Key.SPACE):
			//Activamos/desactivamos la herramienta herramienta.
			trace("BEL: pulsado espacio + pintando" + pintando);
				if (pintando==false){
					activarHerramienta();}
				else{
					desactivarHerramienta();}
				break;
			case (Key.ENTER):
				trace("tecla por defecto");
				break;
		}

		//si estoy pintando, ad+ de lo anterior y dependiendo de la herramienta dibujo
		//pintamos líneas, círculos,...
		trace ("BEL: pintando recoger coordenadas teclado" + pintando);
		if (pintando == true)
			pinta();
		updateAfterEvent();
	}
	
	private function activarHerramienta(){
		var Cursor2:Object = new Object();//locales del cursor
		
		Cursor2.x = (Cursor._x);
		Cursor2.y = (Cursor._y);
		this.globalToLocal(Cursor2);		
		
		if (dentroDelLienzo(Cursor._x, Cursor._y)){		
			pintando = true;
			herramientaUtilizada.inicializarPintado(Cursor2.x, Cursor2.y, this, this.getNextHighestDepth());
			if (desactivar == true){
				desactivarLienzoTecladoActivo;
			}
			else{
				if (vieneDeTeclado){
					this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
					this.onMouseDown=function(){};
					this.onMouseMove=function(){};
				}
				else{
					this.onMouseDown=Delegate.create(this,desactivarHerramienta);		
					this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
					this.onKeyDown = function(){};
				}
			}
		}
	}
	
	private function desactivarHerramienta(){
		//cuando pulsamos otra vez el botón izquierdo del mouse o el botón de selección del teclado
		//se desactiva la herramienta y se reestablece el estado inicial
		//el cursor se puede mover sin pintar y se prepara el pintador para volver a pintar mas adelante.
		if (dentroDelLienzo(Cursor._x, Cursor._y)){
			pintando = false;
			herramientaUtilizada.finalizarPintado();
			if (vieneDeTeclado){
				this.onKeyDown = Delegate.create(this,recogerCoordenadasTeclado);
				this.onMouseDown=function(){};
				this.onMouseMove=function(){};				
			}
			else{
				this.onMouseDown=Delegate.create(this,activarHerramienta);		
				this.onMouseMove=Delegate.create(this,recogerCoordenadasRaton);
				this.onKeyDown = function(){};
			}
		}
		updateAfterEvent();
	}
	
	function pinta(){
		var Cursor2:Object = new Object();//locales del cursor
		if (pintando == true){
			if (hayCursor == true){
				Cursor2.x = (Cursor._x);
				Cursor2.y = (Cursor._y);
				this.globalToLocal(Cursor2);
				if (dentroDelLienzo (Cursor._x, Cursor._y)){
					herramientaUtilizada.pintar(Cursor2.x, Cursor2.y, meSaliPintando);
					if (meSaliPintando == true) {
						meSaliPintando = false;
					}
				}
			}
		}		
	}
	
}