/*	Clase Mascota
	Autor: Alvaro Faraco Martinez
	Fecha: 14 de octubre de 2008
 */

class Mascota
{//Clase Mascota

	private var _debug:Boolean = false;

	//Atributos privados de la clase
	private var _llamante:Object;
	private var _mascota1:MovieClip;
	private var _mascota2:MovieClip;
	private var _activa:String;
	private var _oculta:Boolean;

	//Constructor de la clase
	public function Mascota(llamante:Object)
	{
		_llamante = llamante;
		_mascota1 = _llamante.createEmptyMovieClip("mascota1", _llamante.getNextHighestDepth());
		_mascota2 = _llamante.createEmptyMovieClip("mascota2", _llamante.getNextHighestDepth());
		_activa = "ninguna";
		_oculta = true;
	}

	//coordenadas(x, y)
	public function coordenadas(x:Number, y:Number)
	{
		_mascota1._x = x;
		_mascota1._y = y;
		_mascota2._x = x;
		_mascota2._y = y;
	}

	//cargarAccion(accion)
	public function cargarAccion(accion:String)
	{
		if(_debug) trace("*** Cargando accin de mascota: " + accion);
		_llamante.mascota.accion = accion;
		var cargador:MovieClipLoader = new MovieClipLoader();
		var escuchador:Object = new Object();
		cargador.addListener(escuchador);
		var ruta:String = "";
		if(_level0.ruta != undefined)
		{
			ruta = _level0.ruta;
		}
		var ambito:Object = this;
		switch(_activa)
		{
			case "ninguna":
				cargador.loadClip(ruta + "../lib/mascota.swf", "mascota1");
				_activa = "mascota1";
				break;
			case "mascota1":
				escuchador.onLoadInit = function()
				{
					ambito._mascota1._visible = false;
					ambito._llamante.loadClip("mascota2", "mascota2");
					ambito._activa = "mascota2";
				}
				cargador.loadClip(ruta + "../lib/mascota.swf", "mascota2");
				break;
			case "mascota2":
				escuchador.onLoadInit = function()
				{
					ambito._mascota2._visible = false;
					ambito._llamante.loadClip("mascota1", "mascota1");
					ambito._activa = "mascota1";
				}
				cargador.loadClip(ruta + "../lib/mascota.swf", "mascota1");
				break;
		}
		_oculta = false;
	}

	//mostrar()
	public function mostrar()
	{
		if(_debug) trace("*** Mostrando mascota");
		_mascota1._visible = true;
		_mascota2._visible = true;
	}

	//ocultar()
	public function ocultar()
	{
		if(_debug) trace("*** Ocultando mascota");
		_mascota1._visible = false;
		_mascota2._visible = false;
		_oculta = true;
	}

	//estaOculta()
	public function estaOculta():Boolean
	{
		return _oculta;
	}

	//limpiar()
	public function limpiar()
	{
		_mascota1.removeMovieClip();
		_mascota2.removeMovieClip();
		_activa = "ninguna";
	}

}//Clase Mascota
