/*
Estructura almacenada:

[A|n:5|
   0:[B|n:5|
       0:[C|c:0|e:3|i:0|a:0|f:0]|
       1:[C|c:0|e:3|i:0|a:0|f:0]|
       2:[C|c:0|e:3|i:0|a:0|f:0]|
       3:[C|c:0|e:3|i:0|a:0|f:0]|
       4:[C|c:0|e:3|i:0|a:0|f:0]|
       i:0|c:0]|
   1:[B|n:6|
       0:[C|c:0|e:4|i:0|a:0|f:0]|
       1:[C|c:0|e:4|i:0|a:0|f:0]|
       2:[C|c:0|e:4|i:0|a:0|f:0]|
       3:[C|c:0|e:4|i:0|a:0|f:0]|
       4:[C|c:0|e:4|i:0|a:0|f:0]|
       5:[C|c:0|e:4|i:0|a:0|f:0]|
       i:0|c:0]|
   2:[B|n:5|
       0:[C|c:0|e:3|i:0|a:0|f:0]|
       1:[C|c:0|e:3|i:0|a:0|f:0]|
       2:[C|c:0|e:3|i:0|a:0|f:0]|
       3:[C|c:0|e:3|i:0|a:0|f:0]|
       4:[C|c:0|e:3|i:0|a:0|f:0]|
       i:0|c:0]|
   3:[B|n:5|
       0:[C|c:0|e:4|i:0|a:0|f:0]|
       1:[C|c:0|e:4|i:0|a:0|f:0]|
       2:[C|c:0|e:4|i:0|a:0|f:0]|
       3:[C|c:0|e:4|i:0|a:0|f:0]|
       4:[C|c:0|e:4|i:0|a:0|f:0]|
       i:0|c:0]|
   4:[B|n:5|
       0:[C|c:0|e:4|i:0|a:0|f:0]|
       1:[C|c:0|e:4|i:0|a:0|f:0]|
       2:[C|c:0|e:4|i:0|a:0|f:0]|
       3:[C|c:0|e:4|i:0|a:0|f:0]|
       4:[C|c:0|e:4|i:0|a:0|f:0]|
       i:0|c:0]|
   o:0
]

*/


class ParserEvaluacion 
{
	private var _index:Number;
	private var _cadena:String;
	private var _result:Array;
	private var _ok:Boolean;
	
	private var _lastChar:String;
		
	public function ParserEvaluacion()
	{
	}
	
	public function serializa( e:Array )
	{
		var nE = e.length;
		var res:String = "[A|n:" + nE;
			
		for ( var i:Number = 0; i < nE; i++ )
		{
			var oa:Array = e[i];
			var oaN:Number = oa.length;
	
			res += "|" + i + ":" + "[B|n:" + oaN;
			
			for ( var j:Number = 0; j < oaN; j++ )
			{
				var gea:GestorEvaluacionActividad = oa[j];
				
				var completo2:Number = ( gea["completo"] ? 1 : 0 );
				
				res += "|" + j + ":" + "[C|c:" + completo2 + 
						"|e:" + gea.obtenerNelementos() + 
						"|i:" + gea.obtenerIntentos() + 
						"|a:" + gea.obtenerAciertos() + 
						"|f:" + gea.obtenerFallos() + "]";
			}
			
			var iniciado:Number = ( oa.iniciado ? 1 : 0 );
			var completo:Number = ( oa.completo ? 1 : 0 );
			
			res += "|i:" + iniciado + "|c:" + completo + "]";
					
		}
		
		res += "|o:" + e.oas_ejecutadas + "]";
		
		return res;
	}
	
	public function deserializa( cadena:String ) : Array
	{
		_index = 0;
		_cadena = cadena;
		_result = null;
		_ok = true;

		//_level100.log.htmlText += "[" + cadena + "]";

		parseElementoA();

		return ( _ok ? _result : null );
	}
	
	private function parseElementoA()
	{
		var tipo:String = parseHeader();
		if ( !_ok || tipo != "A" ) return;

		var n:Number = parseParam("n");
		if ( !_ok ) return;
				
		_result = new Array( n );
		
		//_level100.log.htmlText += "Inicio Bucle A";
		
		for ( var i:Number = 0; i < n; i++ )
		{
			consumeChar( "|" );
			if ( !_ok ) return;
		
			var iStr:String = parseIdentifier();
			if ( !_ok || ( Number( iStr ) != i ) ) return;
			
			consumeChar( ":" );
			if ( !_ok ) return;
			
			var objB:Array = parseElementoB();
			if ( !_ok ) return;

			_result[ i ] = objB;
			
		}

		//_level100.log.htmlText += "Fin Bucle A";

		consumeChar( "|" );
		if ( !_ok ) return;

		var oas_ejecutadas:Number = parseParam("o");
		if ( !_ok ) return;
				
		_result.oas_ejecutadas = oas_ejecutadas;
		
		consumeChar( "]" );		
	}
	
	private function parseElementoB() : Array
	{
		var res:Array = null;
		
		var tipo:String = parseHeader();
		if ( !_ok || tipo != "B" ) return res;
		
		var n:Number = parseParam("n");
		if ( !_ok ) return res;
		
		var resTmp:Array = new Array( n );
		
		for ( var i:Number = 0; i < n; i++ )
		{
			consumeChar( "|" );
			if ( !_ok ) return res;
		
			var iStr:String = parseIdentifier();
			if ( !_ok || ( Number( iStr ) != i ) ) return res;
			
			consumeChar( ":" );
			if ( !_ok ) return res;
			
			var objC:GestorEvaluacionActividad = parseElementoC();
			if ( !_ok ) return res;

			resTmp[ i ] = objC;						
		}
		
		consumeChar( "|" );
		if ( !_ok ) return res;

		var iniciado:Number = parseParam("i");
		if ( !_ok ) return res;
		
		resTmp.iniciado = ( iniciado == 1 ? true : false );

		consumeChar( "|" );
		if ( !_ok ) return res;

		var completo:Number = parseParam("c");
		if ( !_ok ) return res;
		
		resTmp.completo = ( completo == 1 ? true : false );

		consumeChar( "]" );
		if ( !_ok ) return res;

		res = resTmp;

		return res;
	}
	

	private function parseElementoC() : GestorEvaluacionActividad
	{
		var res:GestorEvaluacionActividad = null;
		
		var tipo:String = parseHeader();
		if ( !_ok || tipo != "C" ) return res;
		
		var completo:Number = parseParam("c");
		if ( !_ok ) return res;

		consumeChar( "|" );
		if ( !_ok ) return res;

		var nElem:Number = parseParam("e");
		if ( !_ok ) return res;
		
		consumeChar( "|" );
		if ( !_ok ) return res;

		var intentos:Number = parseParam("i");
		if ( !_ok ) return res;
		
		consumeChar( "|" );
		if ( !_ok ) return res;

		var aciertos:Number = parseParam("a");
		if ( !_ok ) return res;
		
		consumeChar( "|" );
		if ( !_ok ) return res;

		var fallos:Number = parseParam("f");
		if ( !_ok ) return res;
		
		consumeChar( "]" );
		if ( !_ok ) return res;

		res = new GestorEvaluacionActividad( nElem, intentos, aciertos, fallos );
		res[ "completo" ] = ( completo == 1 ? true : false );

		return res;
	}

	
	private function parseHeader():String
	{
		var res:String = "";
		
		consumeChar( "[" );
		if ( !_ok ) return res;
		
		var letra:String = parseIdentifier();
		if ( !_ok ) return res;

		consumeChar( "|" );
		if ( !_ok ) return res;

		res = letra;		
		return res;
	}
	
	
	private function parseParam( nombre:String ) : Number
	{
		var res:Number = null;

		var tmp:String = parseIdentifier();		
		if ( !_ok || ( tmp != nombre ) ) return res;
		
		consumeChar( ":" );
		if ( !_ok ) return res;

		var tmp:String = parseIdentifier();		
		if ( !_ok ) return res;

		res = Number( tmp );
		return res;
	}
	
	private function parseIdentifier(): String
	{
		var res:String = "";
		var ch:String = "";
		
		do {
			res += parseChar();
			if ( !_ok ) return;
			
			ch = peekChar();
			if ( !_ok ) return;
		} while ( ( ch != ":" ) && ( ch != "|" ) && ( ch != "]" ) );
		
		return res;
	}
	
	
	private function consumeChar( ch:String )
	{
		var tmp:String = parseChar();
		_ok = ( _ok && ( tmp == ch ) );
	}
	
	private function parseChar():String
	{
		var res:String = "";
		
		if ( _index < _cadena.length )
		{
			res = _lastChar = _cadena.charAt( _index++  );
		}
		else
		{
			_ok = false;
		}
		
		return res;
	}

	private function peekChar():String
	{
		var res:String = "";
		
		if ( _index < _cadena.length )
		{
			res = _cadena.charAt( _index );
		}
		else
		{
			_ok = false;
		}
		
		return res;
	}

}

