/*

var sample:Array = 
[
   {
     escena: 1,
     item: clip_tarea_3,
     prologo: function( script:Script ):Void { _level100.log.htmlText += "Prologo 1"; },
     epilogo: function( script:Script ):Void { _level100.log.htmlText += "Epilogo 1"; }
   },
   {
     escena: 2,
     item: clip_tarea_1,
     prologo: function( script:Script ):Void { _level100.log.htmlText += "Prologo 2"; },
     epilogo: function( script:Script ):Void { _level100.log.htmlText += "Epilogo 2"; }
   },
   {
     escena: 3,
     prologo: function( script:Script ):Void { _level100.log.htmlText += "Prologo 3"; },
     epilogo: function( script:Script ):Void { _level100.log.htmlText += "Epilogo 3"; }
   },
   {
     escena: 3,
     item: clip_tarea_2,
     prologo: function( script:Script ):Void { _level100.log.htmlText += "Prologo 3"; },
     epilogo: function( script:Script ):Void { _level100.log.htmlText += "Epilogo 3"; },
     evento: "explicacion"
   }
];


*/

import utilidades;

class Script {

  private var _data:Array;
  private var _index:Number;
  private var _context;
  private var _ejecutando:Boolean;
  
  public function Script( context ) 
  {
  	_index = -1;
  	_data = null;
  	_context = context;
  	_ejecutando = false;
  }
  
  public function ejecutando():Boolean
  {
  	//_context.log.htmlText += "Pos:" + _index + " - " + _ejecutando;
  	
  	return _ejecutando;
  }


  public function inicializa( data:Array ) 
  {
  	_data = data;
  	_index = 0;
  	_ejecutando = true;
  	
  	ejecuta();
  }
  
  
  public function termina()
  {
  	_index = -1;
  	_data = null;
  	_ejecutando = false;
  }
  
  public function avanza()
  {
  	var res:Boolean = false;

		if ( _ejecutando )
		{
			ejecutaEpilogo();
			if ( _index == _data.length - 1 )
			{
				termina();
			}
		}
  	
		if ( _ejecutando && ( _index >= 0 ) && ( _index < _data.length - 1 ) )
		{
			_index++;
  		ejecuta();
			res = true;
		}
		
		return res;
  }
  
  public function retrocede()
  {
  	var res:Boolean = false;
  	
		if ( _ejecutando && ( _index > 0 ) && ( _index < _data.length ) )
		{			
			_index--;
  		ejecuta();
			res = true;
		}
		
		return res;
  }
  
  
  private function ejecuta() : Boolean
  {
//_context.log.htmlText += "Inicio: ejecuta() - I:E1";

  	var res:Boolean = false;
  	
  	if ( _ejecutando && ( _index >= 0 ) && ( _index < _data.length ) )
  	{
  		var o:Object = _data[ _index ];
  		if ( o.prologo )
  		{
  			o.prologo ( this );
  		}
  		
			var item:MovieClip = o.item;
			
			if ( item != undefined )
			{
				utilidades.crearMarcador( item );
			}
			else
			{
				utilidades.crearMarcador();
			}
			
			var escena:Number = o.escena;
			var evento:String = o.evento || "_nulo_";

//_context.log.htmlText += "E:" + escena + " - " + evento + "-" + item;

			if ( escena )
			{
				_context.gAcces.gSincro.escena(escena,true,true,evento);  // Eplogo ejecutado en diferido
			}
			else
			{
				continua(); // Simula fin de audio: ejecucin de diferido...
			}
			res = true;
  	}
  	
//_context.log.htmlText += "Fin: ejecuta() - F:E1";

  	return res;	
  }
  
  private function ejecutaEpilogo() : Boolean
  {
  	var res:Boolean = false;
  	
  	if ( _ejecutando && ( _index >= 0 ) && ( _index < _data.length ) )
  	{
  		var o:Object = _data[ _index ];

  		if ( o.epilogo )
  		{
  			o.epilogo ( this );
  		}
  		
  		res = true;
		}

		return res;
  }
 
	public function continua()
	{
//_context.log.htmlText += "Inicio: continua() - I:C1";
		//var res:Boolean = ejecutaEpilogo();
		//if ( res )
		//{
  		var res:Boolean = avanza(); 
			if ( !res )
			{
				termina();
			}
		//}
//_context.log.htmlText += "Fin: continua() - F:C1";
	}

}