﻿/*	Clase VentanaConfiguracion
	Autor: Alvaro Faraco Martinez
	Fecha: 3 de julio de 2008
 */

import configuracion.GestorAccesibilidad;
import configuracion.GestorConfiguracion;
import configuracion.GestorRaton;
import configuracion.GestorTeclado;

class VentanaConfiguracion
{//Clase VentanaConfiguracion

	private var _debug:Boolean = false;
	//Atributos privados de la clase
	private var _ventana:MovieClip;
	private var _cargada:Boolean;
	private var _oculta:Boolean;
	private var _keyListener:Object;
	private var _grupoBloqueado:String;
	private var _gestorAccesibilidad:GestorAccesibilidad;
	private var _dificultadActiva:Boolean;

	//Constructor de la clase
	public function VentanaConfiguracion( dificultadActiva )
	{
		_cargada = false;
		_dificultadActiva = ( dificultadActiva == true );
	}

	//cargar(gestorAccesibilidad)
	public function cargar(gestorAccesibilidad:GestorAccesibilidad)
	{
		_gestorAccesibilidad = gestorAccesibilidad;
	}

	//enlazarVentana(ventana)
	public function enlazarVentana(ventana:MovieClip)
	{
		_ventana = ventana;
	}

	//onLoadInit(mc)
	function onLoadInit(mc:MovieClip)
	{
		//Ventana cargada y primer fotograma ejecutado
		mostrarVentanaAux();
	}

	//estaVentanaOculta():Boolean
	public function estaVentanaOculta():Boolean
	{
		return _oculta;
	}

	//estaVentanaCargada():Boolean
	public function estaVentanaCargada():Boolean
	{
		return _cargada;
	}

	//mostrarVentana()
	public function mostrarVentana()
	{
		if(_debug) trace("*** Mostrando la ventana de configuracion");
		if(!_cargada)
		{
			var cargador:MovieClipLoader = new MovieClipLoader();
			cargador.addListener(this);
			cargador.loadClip(_gestorAccesibilidad.obtenerRuta() + "../lib/ventanaConfiguracion.swf", 200);
			//Ventana de configuracion cargada
			_cargada = true;
		}
		else
		{
			mostrarVentanaAux();
		}
	}

	//mostrarVentanaAux()
	private function mostrarVentanaAux()
	{
		//Paro la mascota
		_gestorAccesibilidad.gSincro.gSubtitulos._objRefuerzo.cargarAccion("parado");
		_gestorAccesibilidad.gSincro.gSubtitulos.detener();
		_gestorAccesibilidad.gSincro.gSubtitulos.clear();
		//Guardo el grupo bloqueado y voy a undefined
		_grupoBloqueado = _gestorAccesibilidad.gGrupos.darGrupoBloqueado();
		_gestorAccesibilidad.gGrupos.irA(undefined, true);
		_gestorAccesibilidad.gTeclado.Bloquear();
		_gestorAccesibilidad.gRaton.Bloquear();
		_gestorAccesibilidad.gBarridos.detener();
		_gestorAccesibilidad.gBarridos.capturadorPulsador.detener();
		_gestorAccesibilidad.gSincro.gSubtitulos.pause(true);
		//Activo un escuchador de teclado para la ventana de créditos
		var scope:Object = this;
		_keyListener = new Object();
		Key.addListener(_keyListener);
		_keyListener.onKeyDown = function()
		{
			if(Key.isDown(Key.CONTROL) && Key.isDown(Key.SHIFT) && Key.isDown(Key.ENTER))
			{
				_level0.creditos.mostrarVentana();
			}
		}
		escribirInfo();
		Selection.setFocus(_ventana.cmb_dificultad);
		_ventana._visible = true;
		_oculta = false;
	}

	//ocultarVentana()
	public function ocultarVentana()
	{
		if(_debug) trace("*** Ocultando ventana de configuracion");
		Selection.setFocus(null);
		_ventana._visible = false;
		_gestorAccesibilidad.gTeclado.Desbloquear();
		if(_grupoBloqueado != undefined)
		{
			_gestorAccesibilidad.gGrupos.irA(_grupoBloqueado, true);
		}
		_gestorAccesibilidad.gRaton.Desbloquear();
		_gestorAccesibilidad.gSincro.gSubtitulos.play();
		Key.removeListener(_keyListener);
		_oculta = true;
	}

	//escribirTexto()
	public function escribirTexto()
	{
		//Se muestra el texto de la ventana de configuracion en el idioma seleccionado
		_ventana.txd_dificultad.text = _gestorAccesibilidad.idioma["txd_dificultad"].texto;
		_ventana.txd_modo.text = _gestorAccesibilidad.idioma["txd_modo"].texto;
		_ventana.rad_normal.label = _gestorAccesibilidad.idioma["rad_normal"].texto;
		_ventana.rad_bauto.label = _gestorAccesibilidad.idioma["rad_bauto"].texto + ":";
		_ventana.txd_bautoint.text = _gestorAccesibilidad.idioma["txd_bautoint"].texto;
		_ventana.rad_bmanu.label = _gestorAccesibilidad.idioma["rad_bmanu"].texto;
		_ventana.txd_idioma.text = _gestorAccesibilidad.idioma["txd_idioma"].texto;
		_ventana.txd_sonido.text = _gestorAccesibilidad.idioma["txd_sonido"].texto;
		_ventana.chk_locuciones.label = _gestorAccesibilidad.idioma["chk_locuciones"].texto;
		_ventana.chk_adescripcion.label = _gestorAccesibilidad.idioma["chk_adescripcion"].texto;
		_ventana.txd_volumen.text = _gestorAccesibilidad.idioma["txd_volumen"].texto;
		_ventana.txd_subtitulos.text = _gestorAccesibilidad.idioma["txd_subtitulos"].texto;
		_ventana.chk_subtitulos.label = _gestorAccesibilidad.idioma["chk_subtitulos"].texto + ":";
		_ventana.txd_subsduracion.text = _gestorAccesibilidad.idioma["txd_subsduracion"].texto;
		_ventana.txd_cfgteclas.text = _gestorAccesibilidad.idioma["txd_cfgteclas"].texto;
		_ventana.btn_cfgteclas.label = _gestorAccesibilidad.idioma["btn_cfgteclas"].texto;
		_ventana.btn_restaurar.label = _gestorAccesibilidad.idioma["btn_restaurar"].texto;
		_ventana.btn_cancelar.label = _gestorAccesibilidad.idioma["btn_cancelar"].texto;
		_ventana.btn_aceptar.label = _gestorAccesibilidad.idioma["btn_aceptar"].texto;
		//Se establece el formato del texto de la ventana
		var negrita:TextFormat = new TextFormat("Arial", 12, 0x000000, true);
		_ventana.txd_dificultad.setTextFormat(negrita);
		_ventana.txd_modo.setTextFormat(negrita);
		_ventana.txd_bautoint.setTextFormat(negrita);
		_ventana.txd_idioma.setTextFormat(negrita);
		_ventana.txd_sonido.setTextFormat(negrita);
		_ventana.txd_volumen.setTextFormat(negrita);
		_ventana.txd_subtitulos.setTextFormat(negrita);
		_ventana.txd_subsduracion.setTextFormat(negrita);
		_ventana.txd_cfgteclas.setTextFormat(negrita);
	}

	//escribirInfo()
	public function escribirInfo()
	{
		//Se escribe el texto de la ventana de configuracion en el idioma seleccionado
		escribirTexto();
		//Extraigo el gestor de configuracion
		var gestorConfiguracion:GestorConfiguracion = _gestorAccesibilidad.gConfig;
		//Se muestran los valores de configuracion seleccionados
		_ventana.cmb_dificultad.selectedIndex = gestorConfiguracion.GetDificultad();		
		_ventana.grp_modo.selectedData = gestorConfiguracion.GetModoNavegacion();
		_ventana.txi_intervalo.text = gestorConfiguracion.GetIntervaloBarrido() / 1000;
		for(var i:Number = 0; i < _gestorAccesibilidad.idiomasLabels.length; ++i)
		{
			if(_gestorAccesibilidad.idiomasLabels[i] == gestorConfiguracion.GetIdioma())
			{
				_ventana.cmb_idioma.selectedIndex = i;
			}
		}
		_ventana.chk_locuciones.selected = gestorConfiguracion.GetLocuciones();
		_ventana.chk_adescripcion.selected = gestorConfiguracion.GetAudioDescripcion();
		_ventana.txi_volumen.text = gestorConfiguracion.GetVolumen();
		_ventana.chk_subtitulos.selected = gestorConfiguracion.GetSubtitulos();
		_ventana.txi_duracion.text = gestorConfiguracion.GetDuracionTextos() / 1000;
	}


	//escribirDificultad
	public function escribirDificultad()
	{
		var n:Number = ( _dificultadActiva ? 2 : 0 );
		for(var i:Number = 0; i <= n; ++i)
		{
			_ventana.cmb_dificultad.addItem(_gestorAccesibilidad.idioma["lbl_dificultad_" + i].texto);
		}
	}

	//mostrarIdiomas()
	public function escribirIdiomas()
	{
		for(var i:Number = 0; i < _gestorAccesibilidad.idiomasLabels.length; ++i)
		{
			_ventana.cmb_idioma.addItem(_gestorAccesibilidad.idiomasLabels[i]);
		}
	}

	//aplicarConfiguracion()
	public function aplicarConfiguracion()
	{
		var gestorConfiguracion:GestorConfiguracion = _gestorAccesibilidad.gConfig;
		if(_debug) trace("*** Aplicando la nueva configuracion");
		//Intervalo de barrido
		//Es importante que el intervalo de barrido se establezca antes que el modo de navegacion
		if(Number(_ventana.txi_intervalo.text) * 1000 != gestorConfiguracion.GetIntervaloBarrido())
		{
			if(_debug) trace("Intervalo: " + Number(_ventana.txi_intervalo.text) + " segundos");
			gestorConfiguracion.SetIntervaloBarrido(Number(_ventana.txi_intervalo.text) * 1000);
		}
		//Modo de navegacion
		if(_ventana.grp_modo.selectedData != gestorConfiguracion.GetModoNavegacion())
		{
			if(_debug) trace("Modo de navegacion: " + _ventana.grp_modo.selectedData);
			gestorConfiguracion.SetModoNavegacion(_ventana.grp_modo.selectedData);
		}
		//Locuciones
		if(Boolean(_ventana.chk_locuciones.selected) != gestorConfiguracion.GetLocuciones())
		{
			if(_debug) trace("Locuciones: " + Boolean(_ventana.chk_locuciones.selected));
			gestorConfiguracion.SetLocuciones(Boolean(_ventana.chk_locuciones.selected));
		}
		//Audio-descripcion
		if(Boolean(_ventana.chk_adescripcion.selected) != gestorConfiguracion.GetAudioDescripcion())
		{
			if(_debug) trace("Audio-descripcion: " + Boolean(_ventana.chk_adescripcion.selected));
			gestorConfiguracion.SetAudioDescripcion(Boolean(_ventana.chk_adescripcion.selected));
		}
		//Volumen
		if(Number(_ventana.txi_volumen.text) != gestorConfiguracion.GetVolumen())
		{
			if(_debug) trace("Volumen: " + Number(_ventana.txi_volumen.text) + "%");
			gestorConfiguracion.SetVolumen(Number(_ventana.txi_volumen.text));
		}
		//Subtitulos
		if(Boolean(_ventana.chk_subtitulos.selected) != gestorConfiguracion.GetSubtitulos())
		{
			if(_debug) trace("Subtitulos: " + Boolean(_ventana.chk_subtitulos.selected));
			gestorConfiguracion.SetSubtitulos(Boolean(_ventana.chk_subtitulos.selected));
		}
		//Duracion de textos
		if(Number(_ventana.txi_duracion.text) * 1000 != gestorConfiguracion.GetDuracionTextos())
		{
			if(_debug) trace("Duracion de textos: " + Number(_ventana.txi_duracion.text) + " segundos");
			gestorConfiguracion.SetDuracionTextos(Number(_ventana.txi_duracion.text) * 1000);
		}
		gestorConfiguracion.GuardarConfiguracion();
	}

	//aplicarDificultad()
	public function aplicarDificultad()
	{
		var gestorConfiguracion:GestorConfiguracion = _gestorAccesibilidad.gConfig;
		if(_debug) trace("*** Aplicando la dificultad seleccionada");
		if(_debug) trace("Dificultad: " + _ventana.cmb_dificultad.selectedItem["label"]);
		gestorConfiguracion.SetDificultad(_ventana.cmb_dificultad.selectedIndex);
	}

	//aplicarIdioma()
	public function aplicarIdioma()
	{
		var gestorConfiguracion:GestorConfiguracion = _gestorAccesibilidad.gConfig;
		if(_debug) trace("*** Aplicando el idioma seleccionado");
		if(_debug) trace("Idioma: " + _ventana.cmb_idioma.selectedItem["label"]);
		gestorConfiguracion.SetIdioma(_ventana.cmb_idioma.selectedItem["label"]);
		//Se recarga el XML de idioma con el idioma elegido en la ventana
		_gestorAccesibilidad.establecerIdioma(gestorConfiguracion.GetIdioma());
	}

}//Clase VentanaConfiguracion
