﻿/*	Clase VentanaTeclas
	Autor: Alvaro Faraco Martinez
	Fecha: 7 de julio de 2008
 */

import configuracion.GestorAccesibilidad;
import configuracion.GestorConfiguracion;
import configuracion.datatypes.MetodosAbreviados;
import configuracion.datatypes.TCombinacion;

class VentanaTeclas
{//Clase VentanaTeclas

	private var _debug:Boolean = false;
	//Atributos privados de la clase
	private var _ventana:MovieClip;
	private var _cargada:Boolean;
	private var _oculta:Boolean;
	private var _gestorAccesibilidad:GestorAccesibilidad;

	//Constructor de la clase
	public function VentanaTeclas()
	{
		_cargada = false;
	}

	//cargar(gestorAccesibilidad)
	public function cargar(gestorAccesibilidad:GestorAccesibilidad)
	{
		_gestorAccesibilidad = gestorAccesibilidad;
	}

	//enlazarVentana(ventana)
	public function enlazarVentana(ventana:MovieClip)
	{
		_ventana = ventana;
	}

	//onLoadInit(mc)
	function onLoadInit(mc:MovieClip)
	{
		//Ventana cargada y primer fotograma ejecutado
		mostrarVentanaAux();
	}

	//estaVentanaOculta():Boolean
	public function estaVentanaOculta():Boolean
	{
		return _oculta;
	}

	//estaVentanaCargada():Boolean
	public function estaVentanaCargada():Boolean
	{
		return _cargada;
	}

	//mostrarVentana()
	public function mostrarVentana()
	{
		if(_debug) trace("*** Mostrando la ventana de configuración de teclado");
		if(!_cargada)
		{
			var cargador:MovieClipLoader = new MovieClipLoader();
			cargador.addListener(this);
			cargador.loadClip(_gestorAccesibilidad.obtenerRuta() + "../lib/ventanaTeclas.swf", 300);
			//Ventana de configuracion de teclado cargada
			_cargada = true;
		}
		else
		{
			mostrarVentanaAux();
		}
	}

	//mostrarVentanaAux()
	private function mostrarVentanaAux()
	{
		Selection.setFocus(_ventana.btn_aceptar);
		_ventana._visible = true;
		_oculta = false;
	}

	//ocultarVentana()
	public function ocultarVentana()
	{
		if(_debug) trace("*** Ocultando la ventana de configuración de teclado");
		_ventana._visible = false;
		_oculta = true;
		Selection.setFocus(_level200.mcp_configuracion.rad_normal);
		escribirInfo();
	}

	//escribirTexto()
	public function escribirTexto()
	{
		_ventana.txd_menuteclado.text = _gestorAccesibilidad.idioma["txd_menuteclado"].texto;
		_ventana.txd_acciones.text = _gestorAccesibilidad.idioma["txd_acciones"].texto;
		_ventana.txd_teclas.text = _gestorAccesibilidad.idioma["txd_teclas"].texto;
		_ventana.txd_seleccion.text = _gestorAccesibilidad.idioma["txd_seleccion"].texto;
		_ventana.txd_avancebarrido.text = _gestorAccesibilidad.idioma["txd_avancebarrido"].texto;
		_ventana.txd_retrocesobarrido.text = _gestorAccesibilidad.idioma["txd_retrocesobarrido"].texto;
		_ventana.txd_avancegrupo.text = _gestorAccesibilidad.idioma["txd_avancegrupo"].texto;
		_ventana.txd_retrocesogrupo.text = _gestorAccesibilidad.idioma["txd_retrocesogrupo"].texto;
		_ventana.btn_editar.label = _gestorAccesibilidad.idioma["btn_editar"].texto;
		_ventana.btn_cancelar.label = _gestorAccesibilidad.idioma["btn_cancelar"].texto;
		_ventana.btn_aceptar.label = _gestorAccesibilidad.idioma["btn_aceptar"].texto;
	}

	//mostrarInfo()
	//Muestra la informacion de la ventana de configuracion de teclado
	public function escribirInfo()
	{
		//Se escribe el texto de la ventana de configuracion en el idioma seleccionado
		escribirTexto();
		//Extraigo el gestor de configuracion
		var gestorConfiguracion:GestorConfiguracion = _gestorAccesibilidad.gConfig;
		//Se muestran los valores de configuracion seleccionados
		_ventana.txi_tseleccion.text = gestorConfiguracion.GetTeclaSeleccion();
		_ventana.txi_tavancebarrido.text = gestorConfiguracion.GetTeclaAvanceBarrido();
		_ventana.txi_tretrocesobarrido.text = gestorConfiguracion.GetTeclaRetrocesoBarrido();
		_ventana.txi_tavancegrupo.text = gestorConfiguracion.GetTeclaAvanceGrupo();
		_ventana.txi_tretrocesogrupo.text = gestorConfiguracion.GetTeclaRetrocesoGrupo();
	}

	//aplicarConfiguracion(teclaSeleccion, teclaAvanceBarrido, teclaRetrocesoBarrido,
	//					   teclaAvanceGrupo, teclaRetrocesoGrupo)
	public function aplicarConfiguracion(teclaSeleccion:String, teclaAvanceBarrido:String,
										 teclaRetrocesoBarrido:String, teclaAvanceGrupo:String,
										 teclaRetrocesoGrupo:String)
	{
		//Extraigo el gestor de configuracion
		var gestorConfiguracion:GestorConfiguracion = _gestorAccesibilidad.gConfig;
		//Se aplica la configuracion
		if(_debug) trace("*** Aplicando la nueva configuración de teclado");
		if(_debug) trace("Ventana: " + _ventana);
		if(teclaSeleccion != undefined)
		{
			_gestorAccesibilidad.gTeclado.Liberar(gestorConfiguracion.GetTeclaSeleccion());
			if(_debug) trace("Tecla de pulsar objecto seleccionado: " + teclaSeleccion);
			gestorConfiguracion.SetTeclaSeleccion(teclaSeleccion);
			_gestorAccesibilidad.gTeclado.Registrar(teclaSeleccion, _gestorAccesibilidad.mascara);
		}
		if(teclaAvanceBarrido != undefined)
		{
			_gestorAccesibilidad.gTeclado.Liberar(gestorConfiguracion.GetTeclaAvanceBarrido());
			if(_debug) trace("Tecla de seleccionar el siguiente objecto: " + teclaAvanceBarrido);
			gestorConfiguracion.SetTeclaAvanceBarrido(teclaAvanceBarrido);
			_gestorAccesibilidad.gTeclado.Registrar(teclaAvanceBarrido, _gestorAccesibilidad.gBarridos._avance);
		}
		if(teclaRetrocesoBarrido != undefined)
		{
			_gestorAccesibilidad.gTeclado.Liberar(gestorConfiguracion.GetTeclaRetrocesoBarrido());
			if(_debug) trace("Tecla de seleccionar el objeto anterior: " + teclaRetrocesoBarrido);
			gestorConfiguracion.SetTeclaRetrocesoBarrido(teclaRetrocesoBarrido);
			_gestorAccesibilidad.gTeclado.Registrar(teclaRetrocesoBarrido, _gestorAccesibilidad.gBarridos._retroceso);
		}
		if(teclaAvanceGrupo != undefined)
		{
			_gestorAccesibilidad.gTeclado.Liberar(gestorConfiguracion.GetTeclaAvanceGrupo());
			if(_debug) trace("Tecla de cambiar de grupo de seleccion: " + teclaAvanceGrupo);
			gestorConfiguracion.SetTeclaAvanceGrupo(teclaAvanceGrupo);
			_gestorAccesibilidad.gTeclado.Registrar(teclaAvanceGrupo, _gestorAccesibilidad.gGrupos._maestro);
		}
		if(teclaRetrocesoGrupo != undefined)
		{
			if(_debug) trace("Tecla de cambiar de grupo de seleccion: " + teclaRetrocesoGrupo);
			gestorConfiguracion.SetTeclaRetrocesoGrupo(teclaRetrocesoGrupo);
			gestorConfiguracion.SetTeclaAvanceGrupo(teclaRetrocesoGrupo);
			_gestorAccesibilidad.gTeclado.Registrar(teclaRetrocesoGrupo, _gestorAccesibilidad.gGrupos._retro_maestro);
		}
		escribirInfo();
	}

	//generarTecla()
	//Funcion que genera una tecla
	//Se supone que se debe ejecutar dentro de un evento de onKeyUp
	public function generarTecla():String
	{
		var teclas:Array = new Array();
		if(Key.isDown(Key.CONTROL))
		{
			teclas.push("Control");
		}
		if(Key.isDown(Key.ALT))
		{
			teclas.push("Alt");
		}
		if(Key.isDown(Key.SHIFT))
		{
			teclas.push("Mayús");
		}
		var codigo:Number = Key.getCode();
		var metodosAbreviados:MetodosAbreviados = new MetodosAbreviados();
		switch(teclas.length)
		{
			case 0:
				var tecla:String = metodosAbreviados.teclaAString(codigo);
				break;
			case 1:
				var combinacion:TCombinacion = metodosAbreviados.cadenaATeclas
					(teclas[0] + "+" + metodosAbreviados.teclaAString(codigo));
				var tecla:String = combinacion.cadena;
				break;
			case 2:
				var combinacion:TCombinacion = metodosAbreviados.cadenaATeclas
					(teclas[0] + "+" + teclas[1] + "+" + metodosAbreviados.teclaAString(codigo));
				var tecla:String = combinacion.cadena;
				break;
		}
		return tecla;
	}

}//Clase VentanaTeclas
