﻿/*Comentarios:
 * Las variables booleanas izquierdoDown, derechoDown y centralDown permiten detectar el momento de la pulsación.
 * Las función utilizada para detectar el evento es ASnative(800,2)(x) con x el valor 1(izd), 2(dcha) ó 4(central)
 * ASnative devuelve una referencia a una función introducida en forma de posición de matriz. 
 * Al parecer, ASnative(800,2) se corresponde con Key.isDown ... 
 * Por tanto, Key.isDown(1) nos da la pulsación del botón izquierdo del ratón, y así sucesivamente.
 *
 * Parece útil, pero debemos adaptarlo para que no vaya en el onEnterFrame...
 *   Con onKeyDown no podemos detectarlo, pero sí que podemos establecer un intervalo de comprobación.
 */
class configuracion.CapturadorPulsador extends Object
{
	private var _intervaloDeCaptura:Number = 40;
	private var _intervalo:Number = 0;
	private var notificar_a:Object;
	
	public var izquierdoDown:Boolean = false;
	public var derechoDown:Boolean = false;
	public var centralDown:Boolean = false;
	public var eventoDeTeclado:Boolean = false;
	
	function CapturadorPulsador(notificar_a:Object, izqDown:Boolean, intervalo:Number){
		this.notificar_a=notificar_a; //Establezco el enlace con el receptor
		
		if (izqDown == true)
			izquierdoDown = true;
		//Compruebo si se especifica un intervalo de polling
		if (intervalo > 0)
			_intervaloDeCaptura = intervalo;
		else
			_intervaloDeCaptura = 40;
		
		//Establezco la escucha temporizada
		_intervalo = setInterval(this, "escuchador",_intervaloDeCaptura);
	}
	
	public function detener(){
		clearInterval(_intervalo);
		_intervalo = 0; //Le doy un valor 0 al intervalo, a modo de cerradura
	}

	public function resumir(){
	if (_intervalo == 0)
		_intervalo = setInterval(this, "escuchador",_intervaloDeCaptura);
	}
	
//	this.onEnterFrame = function() {
	private function escuchador() { 
		//Está pulsado el Botón IZQUIERDO?
//		if (ASnative(800, 2)(1)) { 
		if (Key.isDown(1)){
			if (izquierdoDown == false) {
				izquierdoDown = true;
				trace ("Pulsado el botón IZQUIERDO");
				//AHORA LANZO LA NOTIFICACIÓN
				notificar_a.Notificar("izquierdo","pulsado");
			}
		}else{
			izquierdoDown = false;
		}

		//Está pulsado el Botón DERECHO?
//		if (ASnative(800, 2)(2)) { 
		if (Key.isDown(2)) { 
			if (derechoDown == false) {
				derechoDown = true;
				trace ("Pulsado el botón DERECHO");
				//AHORA LANZO LA NOTIFICACIÓN
				notificar_a.Notificar("derecho","pulsado");
			}
		}else{
			derechoDown = false;
		}

		//Está pulsado el Botón CENTRAL?
//		if (ASnative(800, 2)(4)) {
		if (Key.isDown(4)) { 
			if (centralDown == false) {
				centralDown = true;
				trace ("Pulsado el botón CENTRAL");
				//AHORA LANZO LA NOTIFICACIÓN
				notificar_a.Notificar("central","pulsado");
				eventoDeTeclado = true;
			}
		}else{
			centralDown = false;
		}
	}

	//Destruye el capturador de pulsadores y libera memoria
	public function Liberar()
	{
		delete this;
	}
}
