﻿/* ME FALTA añadirle LOCUCIONES sincronizadas
 */
 import configuracion.datatypes.Subtitulos;

class configuracion.GestorSincro {
	private var _debug:Boolean = false;
	public var subtitulos:Array; //Los subtítulos
	public var audios:Array; //Sus correspondientes locuciones
	private var _escena:Number;
	private var _padre:Object;
	public var onFinish_bak:Function;
	public var alTerminar:Function;
	public var gSubtitulos:configuracion.datatypes.Subtitulos;
	
	//es el constructor de la clase.
	//pre: Hay que pasarle el objeto llamante
	public function GestorSincro(padre:Object) {
		this._padre = padre;
		this._escena = 0;
	}
	
	//Este método nos devuelve el objeto padre
	public function getPadre()
	{
		return _padre;
	}
	
	//Este método se usa para registrar la caja donde estarán los subtítulos, y se le pasa como parámetro
	//(1) el movieclip que contendrá los subtítulos
	//(2) el tiempo de subtítulos, lo normal es que sea el indicado en la configuración
	//(3) Y la mascota
	public function registrarTextBox(textBox_mc:MovieClip, delay:Number, mascota:MovieClip)
	{
		gSubtitulos = new Subtitulos(this);
		gSubtitulos.registrarTextBox(textBox_mc, delay, mascota);
	}
	
	//Este método se usa para reproducir un desterminada escena (que puede tener uno o varios audios).
	//Al llamar a este método, se reproducirá tanto el audio como el subtítulo
	//pre: Es obligatorio indicar el número de la escena, los demás parámetros son opcionales
	//post: Reproduce el/los audio/s y subtítulo/s correspondientes a la escena 
	public function escena(i:Number, pararAlFinal:Boolean, activarAlTerminar:Boolean,
						   paramAlTerminar:String, irA:Number)
	{
		if ((i > 0) and (i <= subtitulos.length))
		{
			_escena = i - 1;
			onFinish_bak = gSubtitulos.onFinish;
			gSubtitulos.onFinish = function ()
			{
				if (activarAlTerminar == true)
				{
					this.gSincro.alTerminar.call(this.gSincro._padre.gEvAct, paramAlTerminar);
				}
				this.onFinish = this.gSincro.onFinish_bak;
				if (irA != undefined)
				{
					this._limpiar = false;
					this.gSincro.escena(irA, pararAlFinal); 
				}
			}
			gSubtitulos.setText(subtitulos[_escena], audios[_escena], null, pararAlFinal);
		}
		else
		{
			if(_debug) trace("Escena fuera de rango");
			return -1;
		}
	}
	
	//Este método reproduce el audio descriptivo de un determinado objeto
	//Pre: El objeto que se pasa como parámetro debe ser ACCESIBLE
	public function audioDescribir(objetoAccesible:Object)
	{
		gSubtitulos.setText([objetoAccesible._accProps.description], [objetoAccesible._accProps.audio]);
	}
	
	//Este métdodo se usa para repetir la reproducción la última escena que se haya reproducido
	public function repetir(pararAlFinal:Boolean){
		gSubtitulos.setText(subtitulos[_escena], audios[_escena], null, pararAlFinal);
	}
	
	//Este método avanza a la siguiente escena
	public function avanzar(pararAlFinal:Boolean){
		if (_escena < (subtitulos.length-1))
			gSubtitulos.setText(subtitulos[++_escena], audios[_escena], null, pararAlFinal);
		else
			if(_debug) trace("Alcanzado final de subtítulos")
	}
	
	//Este método elige al azar uno de los refuerzos positivos definidos en el archivo de configuración
	public function refuerzoPositivo(irA:Number, activarFinish:Boolean, pararAlFinal:Boolean, paramAlTerminar:String){
		onFinish_bak = gSubtitulos.onFinish;
		if (activarFinish == true){
			gSubtitulos.onFinish = function () {
				if(_debug) trace("onFinish mod con onFinish");
				this.gSincro.alTerminar.call(this.gSincro._padre.gEvAct,paramAlTerminar);
				this.onFinish = this.gSincro.onFinish_bak;
			}
		}
		else {
			gSubtitulos.onFinish = function () {
				if(_debug) trace("onFinish mod");
			}
		}
		var i = Math.ceil(Math.random()*_padre.r_positivos.length); //Selecciono un refuerzo al azar
		//Calculo la locución del refuerzo seleccionado
		var audio:String = seleccionaAudio( 
			_padre.idioma.url_audios_generales, 
			_padre.idioma[_padre.r_positivos[i-1].id_texto].audio_general, 
			_padre.idioma.url_audios, 
			_padre.idioma[_padre.r_positivos[i-1].id_texto].audio 
			);
		var locucionRefuerzo:Array = new Array( audio );
		if(_debug) trace("locucion: " + locucionRefuerzo[0]);
		gSubtitulos.setText(["<b>" + _padre.traducir(_padre.r_positivos[i-1].id_texto) + "</b>"], locucionRefuerzo);
	}
	
	//Este método elige al azar uno de los refuerzos negativos definidos en el archivo de configuración
	public function refuerzoNegativo(irA:Number, activarFinish:Boolean, pararAlFinal:Boolean, paramAlTerminar:String, es:Number, n:Number){
		onFinish_bak = gSubtitulos.onFinish;
		var x:Number;
		if (activarFinish){
			gSubtitulos.onFinish = function () {
				if(_debug) trace("onFinish mod con onFinish");
				this.gSincro.alTerminar.call(this.gSincro._padre.gEvAct,paramAlTerminar);
				this.onFinish = this.gSincro.onFinish_bak;
			}
		}
		else {
			gSubtitulos.onFinish = function () {
				if(_debug) trace("onFinish mod");
			}
		}
		if (es==null){
			var i = Math.ceil(Math.random()*_padre.r_negativos.length); //Selecciono un refuerzo al azar
			//Calculo la locución del refuerzo seleccionado
			var audio:String = seleccionaAudio( 
				_padre.idioma.url_audios_generales, 
				_padre.idioma[_padre.r_negativos[i-1].id_texto].audio_general, 
				_padre.idioma.url_audios, 
				_padre.idioma[_padre.r_negativos[i-1].id_texto].audio 
				);
			var locucionRefuerzo:Array = new Array( audio );
			if(_debug) trace("locucion: " + locucionRefuerzo[0]);
			gSubtitulos.setText(["<b>" + _padre.traducir(_padre.r_negativos[i-1].id_texto) + "</b>"], locucionRefuerzo);
		}
		else {
			x=0;
			var oArrayMensajes:Array = new Array();
			var locucionRefuerzo:Array = new Array();
			while (x<n){
				var audio:String = seleccionaAudio( 
					_padre.idioma.url_audios_generales, 
					_padre.idioma[_padre.arraySubtituloBruto[es].id_texto].audio_general, 
					_padre.idioma.url_audios, 
					_padre.idioma[_padre.arraySubtituloBruto[es].id_texto].audio 
					);
				locucionRefuerzo.push( audio );
				oArrayMensajes.push("<b>" + _padre.traducir(_padre.arraySubtituloBruto[es].id_texto) + "</b>");
				x++;
				es++;
			}
			gSubtitulos.setText(oArrayMensajes, locucionRefuerzo);	
	
		}
	}
	//Este método detiene los subtítulos.
	public function limpiar() {
		gSubtitulos.detener();
		alTerminar=null;
		gSubtitulos.onFinish=null;
		gSubtitulos.onFrase=null;
	}
	
	/*
		Si el fichero1 está especificado, returna su path completo, en caso contrario, usa retorna el fichero2
	*/
	private function seleccionaAudio( path1:String, fichero1:String, path2:String, fichero2:String) : String 
	{
		var res:String = "";
		
		//var _level100 = _padre.gEvAct._level100;
		
		//_level100.log.htmlText += "p1:" + path1 + " - " + fichero1;
		//_level100.log.htmlText += "p2:" + path2 + " - " + fichero2;
		
		if ( fichero1 )
		{
			res = path1 + fichero1;
		}
		else
		{
			res = path2 + fichero2;
		}	
		
		//_level100.log.htmlText += "res:" + res;

		return res;
	}
}
