﻿/*	Clase ParserXML
*/

class configuracion.xmlcnice.ParserXML extends XML
{
	//Atributos privados de la clase
	private var _nodosXML:Array;
	private var _i:Number;
	private var _onLoad:Function;
	private var _referrer:Object;

	//Valores posibles de tipos de nodos
	private static var ELEMENT_NODE:Number = 1;
	private static var TEXT_NODE:Number = 3;

	//Atributos publicos de la clase
	//archiveToLoad es la ruta del archivo XML a cargar
	public var archiveToLoad:String;

	//Constructor de la clase
	public function ParserXML()
	{
		init.apply(this, arguments);
	}

	//init(obj, func, referrer)
	public function init(obj:Array, func:Function, referrer:Object)
	{
		archiveToLoad = new String();
		_i = new Number(0);
		_nodosXML = obj;
		_onLoad = func;
		_referrer = referrer;
		ignoreWhite = true;
	}
	
	//load(archive)
	public function load(archive:String)
	{
		archiveToLoad = archive;
		super.load(archiveToLoad);
	}

	//parse(xml2parse, nodosXML)
	//Realiza la lectura de un nodo XML y, de forma recursiva, la lectura de todo
	//el archivo XML.
	private function parse(xml2parse:XMLNode, nodosXML:Array)
	{
		//currentNode es el nodo XML actual
		var currentNode:XMLNode = xml2parse;
		if(_i++ == 0)
		{
			nodosXML["attributes"] = currentNode.parentNode.attributes;
		}
		if(currentNode.hasChildNodes())
		{
			do
			{
				//currentChild es el nodo XML hijo actual
				var currentChild:XMLNode = currentNode.firstChild;
				do
				{
					//Si currentChild.nodeType es un nodo XML
					if(currentChild.nodeType == ELEMENT_NODE)
					{
						var j:Number = nodosXML.push();
						nodosXML[j] = new Array();
						nodosXML[j].tipo = currentNode.nodeName;
						parse(currentChild, nodosXML[j]);
						break;
					}
					//Si currentChild.nodeType es un nodo de texto
					else if(currentChild.nodeType == TEXT_NODE)
					{
						nodosXML[currentNode.attributes.name] = currentChild.nodeValue.toString();
					}
				}
				while(currentChild = currentChild.nextSibling);
			}
			while(currentNode = currentNode.nextSibling);
		}
		if(!Boolean(--_i))
		{
			_callBack();
		}
	}

	//onLoad(success)
	private function onLoad(success:Boolean)
	{
		if(success)
		{
			parse(firstChild.firstChild, _nodosXML);
		}
		else
		{
			trace("ParserXML.onLoad: Error cargando el archivo XML.");
		}
	}

	//_callBack()
	private function _callBack()
	{
		_onLoad.call(_referrer,true);
	}
}
