﻿import elementoActividad;
import configuracion.GestorAccesibilidad;

class utilidades extends MovieClip{
//Hay un conjunto de funciones que se pueden utilizar en varias actividades

//Javier Cuesta 29-09-08
//funcion que crea varias instancias de movieclips
//Se le pasa un lista de movieclips (que serán los moviclips instanciados),
//una lista de elementos del tipo "elementoActividad", estos elementos deben
//hacer referencia a objetos que se encuentran en la librería de un determinado flash y
//una lista con los movieclips donde se quieren instanciar por ejemplo clip_1,clip_2,...
static function crearInstanciasMC (arrayMC:Array, arrayElementos: Array, arrayClips: Array){
	var id_elemento: String;
	var i:Number;
	var nombre_elemento: String;
	for (i=0; i<arrayMC.length; i++){
		id_elemento = arrayElementos[i].GetId();
		nombre_elemento = arrayElementos[i].GetNombre();
		instanciarMC (arrayMC[i], arrayClips[i], id_elemento, id_elemento);
		arrayElementos[i].PutMovieClip(arrayClips[i]);
	}
}

//Javier Cuesta 29-09-08
//Esta funcion instancia un determinado movieclip sobre otro
//ademas pasa las coordenadas globales a locales, para situar el movieclip en el mismo lugar que el clip sobre el que se instancia
static function instanciarMC (mc: MovieClip, clip: MovieClip, id_mc: String, nombre_mc: String){
	var bound:Object;//para obtener el ancho y el alto 	
	mc = clip.attachMovie(id_mc, nombre_mc, clip.getNextHighestDepth());
	bound=clip.getBounds(mc);
	mc._x = 0;
	mc._y = 0;
	mc._width=bound["xMax"]; //obtengo el ancho del clip
	mc._height =bound["yMax"]; //obtengo el alto del clip
	mc._visible = true;
}

//Javier Cuesta 30-09-08
//Esta funcion vuelca todos las datos que necesitemos de una lista dada de elementos
//a los clips en cuales han sido instanciados, es decir, una vez que se han instanciado
//los elementos, se copian sus datos en el clip que haya correspondido para poder
//trabajar con el propio clip en lugar de trabajar con el elemento, esto se hace
//porque no siempre un clip contiene al mismo elemento.
//Como se aprecia, este método utiliza un método definido en el gestor de accesibilidad.
//se le pasa una lista de elementos del tipo "elementoActividad" y una lista de strings con
//los nombres de los clips donde se han instanciado los elementos.

static function copiarEnTodosClips (listaElem: Array, listaStringClips: Array, gestorAcces: Object){
	var identificador: String;
	var i:Number;
	for (i=0; i<listaElem.length; i++){
		identificador = listaElem[i].GetId();
		gestorAcces.copiarDatosAClip (identificador,listaStringClips[i]);
	}
}

//FUNCION SALIR: Utilizada para cerrar la ventana del navegador.
//1º Para poder cerrar una ventana del navegador es necesario usar javascript
//2º El botón salir funciona en Internet Explorer y opera. En el primero si la página no se abrió dese un enlace javascript muestra una advertencia.
//3º Para que funcione en firefox la ventana tiene que abrirse obligatoriamente con javascript, por ejemplo usando:
//javascript:window.open("http://tellina.cettico.fi.upm.es/nee2008/secuencia27/index.html")
static function salir(){
	if(_level0.carga == "actividad"){
		//getURL("javascript:window.location=\"../../lib/cerrar.html\"");
		//getURL("javascript:window.location.replace(\"../../lib/cerrar.html\")");
		getURL("javascript:window.open(\"../../lib/cerrar.html\", \"_self\")");
	}
	else{
		//getURL("javascript:window.location=\"../lib/cerrar.html\"");
		//getURL("javascript:window.location.replace(\"../lib/cerrar.html\")");
		getURL("javascript:window.open(\"../lib/cerrar.html\", \"_self\")");
	}
}

//Javier Cuesta 30-09-08
//Funcion utilizada para generar un random de una lista
//se le pasa un array y devuelve otro array haciendo un random del
//array pasado como parametro
static function generaArrayRandom(lista:Array):Array {
		var tam:Number = lista.length;
		if (lista.length == 0) {
			return null;
		}
		//Para cargar el array de datos aleatorios
		var arrayTemp:Array = Array(tam);
		var listaOut:Array = new Array(tam);
		for (var i=0; i<tam; i++) {
			arrayTemp[i] = i;
		}
		for (var i=0; i<tam; i++) {
			var temp = random(arrayTemp.length);
			listaOut[i] = lista[arrayTemp[temp]];
			arrayTemp.splice(temp, 1);
			//le quito el valor usado
		}
		return listaOut;
	}

//Javier Cuesta 30-09-08
//Funcion utilizada para escribir en los textos dinamicos de los elementos, el nombre corto que se pasa en el archivo de idioma
//Se le pasa una lista con los nombres de los clips, otra lista con los nombres de los textos dinamicos y el gestor de accesibilidad de la propia acctividad
static function escribirTexto (listaClips: Array, listaTxt: Array, gestorAcces: Object){
	var i:Number;
	for (i=0; i<listaClips.length; i++){
		_root[listaTxt[i]].htmlText = "<b>"+gestorAcces.darNombreCorto(listaClips[i])+"</b>";
	}
}

static function texto (id: String, destino: String, gestorAcces: Object){
		_root[destino].htmlText = "<b>"+gestorAcces.traducir(id)+"</b>";
}

//Javier Cuesta 06-10-08
//Funcion utilizada para generar un lista aleatoria de longitud N (pasado como paramentro)
//se le pasa un array y la longitud de la lista de salida y devuelve otro array que sera una lista aleatoria de longitud N
static function generaElementosRandom(lista:Array, n:Number):Array {
		var tam:Number = lista.length;
		if (lista.length == 0) {
			return null;
		}
		//Para cargar el array de datos aleatorios
		var listaOut:Array = new Array(n);
		var arrayTemp:Array = Array(tam);
		var listaRandom:Array = new Array(tam);
		for (var i=0; i<tam; i++) {
			arrayTemp[i] = i;
		}
		for (var i=0; i<tam; i++) {
			var temp = random(arrayTemp.length);
			listaRandom[i] = lista[arrayTemp[temp]];
			arrayTemp.splice(temp, 1);
			//le quito el valor usado
		}
		for (var i=0; i<n; i++) {
			listaOut[i] = listaRandom[i];
		}
		return listaOut;
	}

//Pone el foco en el objeto indicado como parámetro
//(1) si no se indica ningún parámetro desaparece el foco. 
static function crearMarcador(sel:MovieClip){
	var coord:Object = sel.getBounds(sel);
	var coordAbsolutas:Object = new Object;
	_root["marcador"].clear();
	coordAbsolutas.x = coord.xMin;
	coordAbsolutas.y = coord.yMin;
	sel.localToGlobal(coordAbsolutas);
	if (_root["marcador"] == undefined)
		var clipMarcador:MovieClip = _root.createEmptyMovieClip("marcador", _root.getNextHighestDepth());
	else
		clipMarcador = _root["marcador"];
	var color = 0x0000FF;
	if (_root.gAcces.general.color_marcador != undefined)
		color = _root.gAcces.general.color_marcador; //Lo paso a hexadecimal
	with(clipMarcador) {
		lineStyle(4, color, 75);
		moveTo(coordAbsolutas.x, coordAbsolutas.y);
		lineTo(coordAbsolutas.x + sel._width, coordAbsolutas.y);
		lineTo(coordAbsolutas.x + sel._width, coordAbsolutas.y + sel._height);
		lineTo(coordAbsolutas.x, coordAbsolutas.y + sel._height);
		lineTo(coordAbsolutas.x, coordAbsolutas.y);
	}
}

}